<?php

error_reporting(E_ALL); 
ini_set("display_errors", 0);

require_once('../include/config/config.inc.php');
require_once('../include/functions/functions.php');
function __autoload($class_name) {
    require_once('../include/classes/'.$class_name.'.class.php');
}

$structure = (isset($_POST['form'])) ? $_POST['form'] : false;
$task = (isset($_POST['task'])) ? $_POST['task'] : false;

if ($task == 'login'){
	$admin = new Admin();
	$admin->jsonResponse();
} else if ($task == 'logout'){
	$admin = new Admin();
	$admin->logout();
	$admin->jsonResponse();
} else if ($structure == 'fragments'){
	$fragment = new Fragments();
	if ($task == 'save'){
		$fragment->saveFragment();
	} else if ($task == 'delete'){
		$fragment->deleteFragment();
	} else if ($task == 'forcedelete'){
		$fragment->forceDeleteFragment();
	}
	$fragment->jsonResponse();
} else if ($structure == 'article' || $structure == 'articles' || $structure == 'relations'){
	if ($task == 'save'){
		$article = new Articles();
		$article->saveArticle();
	} else if ($task == 'addFragment'){
		$article = new Articles();
		$article->addFragmentToArticle();
	} else if ($task == 'visibility'){
		$article = new Articles();
		$article->changeVisibilty();
	} else if ($task == 'position'){
		$article = new Articles();
		$article->changePosition();
	} else if ($task == 'delete'){
		$article = new Articles();
		$article->deleteArticle();
	} else if ($task == 'relations'){
		$article = new Relations();
		$article->saveRelations();
	} else if ($task == 'changefield'){
		$article = new Relations();
		$article->emptyRelationOnFieldChange();
	}
	$article->jsonResponse();
} else if ($structure == 'infos'){
	$info = new Infos();
	if ($task == 'save'){
		$info->saveInfos();
	}
	$info->jsonResponse();
} else if ($structure == 'users'){
	$user = new Users();
	if ($task == 'save'){
		$user->saveUser();
	} else if ($task == 'delete'){
		$user->deleteUser();
	}
	$user->jsonResponse();
} else if ($structure == 'tags'){
	$tags = new Tags();
	if ($task == 'save'){
		$tags->saveTag();
	}  else if ($task == 'delete'){
		$tags->deleteTag();
	}
	$tags->jsonResponse();
} else if ($structure == 'schplitzing'){
	if ($task == 'cache'){
		$article = new Articles();
		$article->updateArticleCache();
		$article->jsonResponse();
	}
} else if ($structure == 'connection'){
	if ($task == 'connect'){
		$infos = new Infos();
		$infos->activateConnection();
		$infos->jsonResponse();
	}
}

?>