<?php

class GetRelations extends db {

	protected $unserializekeys = array();
	protected $order = "relationfield";
	protected $table = 'sz_relations';
	
	public function getRelationsById($id){
		$this->id = $id;
		$sql = "SELECT * from  $this->table WHERE articleid='$this->id'";
		$result = $this->fetchSql($sql);
		return $result;
	}
	
	public function getSortedRelations($id){
		$result = $this->getRelationsById($id);
		return $this->sortRelations($result);
	}
	
	public function getRelationsForAllFields($id){
		$result = $this->getRelationsById($id);
		$result = $this->sortRelations($result);
		$result = $this->sortRelationsForAllFields($result);
		return $result;
	}
	
	public function getAllRelations($order=false){
		$sql = "SELECT * from  $this->table";
		$sql .= ($order)? " ORDER BY `$order`":"";
		$result = $this->fetchSql($sql);
		return $result;
	}
	
	public function getRelationsForArticles($articles){
		if (is_array($articles)){
			foreach ($articles as $key=>$article){
				$articles[$key]->relations = $this->getRelationsById($article->id);
			}
		}
		return $articles;
	}
	
	protected function sortRelations($rels){
		$result = false;
		if (is_array($rels)){
			foreach ($rels as $rel){
				$result[$rel->relationfield] = $rel->relationid;
			}
		}
		return $result;
	}
	
	protected function sortRelationsForAllFields($rels){
		$result = false;
		foreach ($this->fields as $field){
			if (isset($rels[$field])){
				$result[$field] = ($rels[$field])? $rels[$field] : 'e';
			} else {
				$result[$field] = 'e';
			}
		}
		return $result;
	}
	
}

?>