<?php  

class Stories extends Admin {

	protected $tableFields = array('id', 'title', 'description', 'story', 'last_changed');
	protected $table = 'sz_stories';
	
	function __construct(){
		parent::__construct();
		$this->id = (isset($_POST['id']))? $_POST['id'] : ((isset($_GET['id']))? $_GET['id'] : false);
	}
	
	public function saveStory(){
		if ($this->logedIn){
			$this->serializeProperties();
			if ($this->id){
				if ($this->update()){
					$this->msg = 'saved';
				}
			} else {
				if ($this->create()){
					$this->msg = 'created';
				}
			}
		}
	}
	
	public function deleteStory(){
		if ($this->logedIn){
			if ($this->id){
				if ($this->dbDelete()){
					$this->msg = 'deleted';
				}
			}
		}
	}

}


?>