<?php  

class Tags extends Admin {

	protected $tableFields = array('id', 'tag', 'description', 'author', 'last_changed');
	protected $table = 'sz_tags';
	
	function __construct(){
		parent::__construct();
		$this->id = (isset($_POST['id'])) ? $_POST['id'] : false;
	}

	public function saveTag(){
		if ($this->logedIn){
			$this->serializeProperties();
			if ($this->id){
				if ($this->update()){
					$this->msg = 'saved';
				}
			} else {
				if ($this->create()){
					$this->msg = 'create';
				}
			}
		}
	}
	
	public function deleteTag(){
		if ($this->logedIn){
			if ($this->id){
				$this->dbDelete();
			}
		}
	}

}


?>