<div id="header_<?= $field ?>" class="edit_header">
	<div class="edit_title"><?= $this->lang['FIELD'] ?> <?= $field ?> - <?= $fieldnames[$field] ?></div>
	<div class="edit_tools">
		<button class="icon plus" title="<?= $this->lang['ADD'] ?>" data-struct="article" data-field="<?= $field ?>" data-next="<?= count($articles)+1 ?>"></button>
	</div>
</div>
<div id="field_container_<?= $field ?>" class="field_container edit" style="width:400px;height:300px">
	<ul class="articlelist" data-field="<?= $field ?>">
		<?php if ($articles): ?>
			<?php foreach ($articles as $article): ?>
				<li class="listed_article<?= ($article->extern)? ' listed_extern':'' ?>" data-id="<?= $article->id ?>" data-sort="<?= $article->sort ?>" data-extern="<?= $article->extern ?>"<?php if($article->extern): ?> data-system="<?= $article->extern_system ?>"  data-articleid="<?= $article->extern_id ?>" data-url="<?= $article->extern_url ?>"<?php endif; ?>>
					<div class="template_icon template_<?= $article->template ?>"></div>
					<div class="article_title<?= ($article->extern)? ' extern_article' : '' ?>"><?= $article->title ?></div>
					<div class="article_connect">
						<button class="connect <?= ($article->extern)? 'extern':'disabled'  ?>" data-struct="article" data-field="<?= $field ?>" data-id="<?= $article->id ?>"  title="<?= $this->lang['SZ_EXTERN'] ?>" data-extern="<?= $article->extern ?>"></button>
						<button class="connect connections" data-struct="article" data-field="<?= $field ?>" data-id="<?= $article->id ?>"  title="<?= $this->lang['SZ_CONNECTIONS'] ?>" data-extern="<?= $article->extern ?>"></button>
						<button class="connect relations" data-struct="article" data-field="<?= $field ?>" data-id="<?= $article->id ?>"  title="<?= $this->lang['SZ_RELATIONS'] ?>" data-extern="<?= $article->extern ?>"></button>
					</div>
					<div class="article_tools">
						<button class="icon delete" data-struct="article" data-field="<?= $field ?>" data-id="<?= $article->id ?>" data-extern="<?= $article->extern ?>" title="<?= $this->lang['DELETE'] ?>"></button>
						<button class="icon edit" data-struct="article" data-field="<?= $field ?>" data-id="<?= $article->id ?>" data-extern="<?= $article->extern ?>" title="<?= $this->lang['EDIT'] ?>"></button>
					</div>
				</li>
			<?php endforeach; ?>
		<?php endif; ?>
	</ul>
</div>