<input type="hidden" name="id" value="<?= $value->id ?>" />
<input type="hidden" name="form" value="fragments" />
<input type="hidden" name="author" value="<?= $this->user ?>" />
<input type="hidden" name="task" value="<?= $this->task ?>" />
<input type="hidden" name="type" value="<?= $value->type ?>" />
<div class="formblock textblock">
	<div class="label"><label class="formlabel" for="title"><?= $this->lang['TITLE'] ?></label></div>
	<input type="text" name="title" class="formfield" value="<?= $value->title ?>" />
</div>
<div class="formblock textblock">
	<div class="label"><label class="formlabel" for="tags"><?= $this->lang['TAG'] ?></label></div>
	<select class="formselect tags" name="tags" size="1">
		<option value=""><?= $this->lang['NOT_TAGGED'] ?></option>
		<?php $tags = new GetTags(); ?>
		<?php foreach ($tags->getTags() as $tag): ?>
			<option value="<?= $tag->id ?>"<?= ($value->tags == $tag->id) ? ' selected' : '' ?>><?= $tag->tag ?></option>
		<?php endforeach; ?>
		<option class="addtag" value="add"><?= $this->lang['ADD_TAG'] ?></option>
	</select>
</div>
<?php if ($value->type == 'text'): ?>
	<div class="formblock ckeditorblock">
		<textarea id="text_<?= $value->id ?>" name="text" class="formtext"><?= $value->text ?></textarea>
	</div><div class="formblock textblock">
		<div class="label"><label class="formlabel" for="source"><?= $this->lang['SOURCE'] ?></label></div>
		<input type="text" name="source" class="formfield" value="<?= $value->source ?>" />
	</div>
	<div class="formblock textblock">
		<div class="label"><label class="formlabel" for="source_url"><?= $this->lang['SOURCE_URL'] ?></label></div>
		<input type="text" name="source_url" class="formfield" value="<?= $value->source_url ?>" />
	</div>
<?php elseif ($value->type == 'headline'): ?>
	<div class="formblock ckeditorblock">
		<textarea id="text_<?= $value->id ?>" name="text" class="formheadline"><?= $value->text ?></textarea>
	</div>
	<div class="formblock textblock">
		<div class="label"><label class="formlabel" for="source"><?= $this->lang['SOURCE'] ?></label></div>
		<input type="text" name="source" class="formfield" value="<?= $value->source ?>" />
	</div>
	<div class="formblock textblock">
		<div class="label"><label class="formlabel" for="source_url"><?= $this->lang['SOURCE_URL'] ?></label></div>
		<input type="text" name="source_url" class="formfield" value="<?= $value->source_url ?>" />
	</div>
<?php elseif ($value->type == 'img'): ?>
	<div class="formblock imgblock">
		<?php if ($value->path): ?>
			<div class="image">
				<?php if ($value->size > 1.33): ?>
					<?php $width = '100'; ?>
				<?php else: ?>
					<?php $width = round(100/MAX_WIDTH*(MAX_HEIGHT*$value->size)); ?>
				<?php endif; ?>
				<img src="<?= MEDIA_PATH.$value->path ?>" width="<?= $width ?>%" />
				<button class="txtbutton replaceimg" title="<?= $this->lang['REPLACE_IMAGE'] ?>" data-replace="<?= $value->path ?>"><?= $this->lang['REPLACE_IMAGE'] ?></button>
			</div>
		<?php else: ?>
			<div class="image" style="display:none">
				<button class="txtbutton replaceimg" title="<?= $this->lang['REPLACE_IMAGE'] ?>" ><?= $this->lang['REPLACE_IMAGE'] ?></button>
			</div>
			<input type="file" name="file" class="formfile" value="">
		<?php endif; ?>	
	</div>
	<div class="formblock textblock">
		<div class="label"><label class="formlabel" for="source"><?= $this->lang['SOURCE'] ?></label></div>
		<input type="text" name="source" class="formfield" value="<?= $value->source ?>" />
	</div>
	<div class="formblock textblock">
		<div class="label"><label class="formlabel" for="source_url"><?= $this->lang['SOURCE_URL'] ?></label></div>
		<input type="text" name="source_url" class="formfield" value="<?= $value->source_url ?>" />
	</div>
<?php elseif ($value->type == 'video'): ?>
	<div class="formblock videoblock">
		<?php if($value->thumb): ?>
			<div class="video">
				<img src="<?= $value->thumb ?>" width="100%" />
				<button class="txtbutton replacevideo" data-replace="<?= $value->path ?>"><?= $this->lang['REPLACE_VIDEO'] ?></button>
			</div>
		<?php else: ?>
			<div class="video" style="display:none">
				<button class="txtbutton replacevideo"><?= $this->lang['REPLACE_VIDEO'] ?></button>
			</div>
		<?php endif; ?>
		<div class="formblock textblock"<?= ($value->thumb)? ' style="display:none"' : '' ?>>
			<div class="label"><label class="formlabel" for="resource"><?= $this->lang['VIDEO_SOURCE'] ?></label></div>
				<select class="formselect smallselect" name="resource" size="1">
						<option value="vimeo"<?= ($value->resource == 'vimeo')? ' selected' : '' ?>><?= $this->lang['VIMEO'] ?></option>
						<option value="youtube"<?= ($value->resource == 'youtube')? ' selected' : '' ?>><?= $this->lang['YOUTUBE'] ?></option>
						<option value="soundcloud"<?= ($value->resource == 'soundcloud')? ' selected' : '' ?>><?= $this->lang['SOUNDCLOUD'] ?></option>
				</select>
		</div>
		<div class="formblock textblock"<?= ($value->thumb)? ' style="display:none"' : '' ?>>
			<div class="label"><label class="formlabel" for="video"><?= $this->lang['URL_OR_ID'] ?></label></div>
			<input type="text" name="video" class="formfield" value="<?= $value->path ?>" />
		</div>
	</div>
<?php endif; ?>