<?php if($fragment): ?>
	<?php if($fragment->type == 'text'): ?>
		<div class="normal"><?= $fragment->text; ?></div>
	<?php elseif ($fragment->type == 'headline'): ?>
		<div class="headline"><?= $fragment->text; ?></div>
	<?php elseif ($fragment->type == 'img'): ?>
		<?php if ($fragment->size > 1.33): ?>
			<?php $width = '100'; ?>
		<?php else: ?>
			<?php $width = round(100/MAX_WIDTH*(MAX_HEIGHT*$fragment->size)); ?>
		<?php endif; ?>
		<img src="<?= MEDIA_PATH.$fragment->path ?>" width="<?= $width ?>%" />
	<?php elseif ($fragment->type == 'video'): ?>
		<?php if ($fragment->resource == 'soundcloud'): ?>
			<div class="normal"><?= $fragment->html; ?></div>
		<?php else: ?>
			<img src="<?= $fragment->thumb ?>" width="100%" />
		<?php endif; ?>
	<?php endif; ?>
<?php endif; ?>