<?php
	error_reporting(E_ALL); 
	ini_set("display_errors", 0);
	ini_set("log_errors", 1);
	ini_set('error_log','error_php.log');
	define( '_BACKEND_VAL', 1 );
	
	require_once('../config/config.inc.php');
	require_once('../functions/functions.php');
	function __autoload($class_name) {
	    require_once('../classes/'.$class_name.'.class.php');
	}
	
	$origin = (strpos($_SERVER['HTTP_HOST'], 'http://') === false)? 'http://'.$_SERVER['HTTP_HOST'].str_replace("include/install/migrate.php", "", $_SERVER['PHP_SELF']) : $_SERVER['HTTP_HOST'].str_replace("include/install/migrate.php", "", $_SERVER['PHP_SELF']);

	$result = false;
	if ($_POST){
		$form = false;
		$result = install();
		foreach ($result as $valid){
			if ($valid != false){
				$form = true;
			}
		}
	} else {
		if (isset($_GET['build'])){
			$form = false;
			$articles = new Articles();
			$articles->updateArticleCache();
		} else {
			$form = true;
		}
	}
	
?><!DOCTYPE HTML>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title>SchplitZing - Migration</title>
	<link rel="stylesheet" type="text/css" href="../public/css/style.css" />
	<link rel="stylesheet" type="text/css" href="../private/css/admin.css" />
	<link rel="stylesheet" type="text/css" href="../public/css/schplitzing.css" />
	<style type="text/css" >
		.label_invalid {
			color: red;
		}
	</style>
	
</head>
<body>
	<div id="edit_submenu_above"><div id="edit_submenu_menu" style="text-transform:none">
		<a href="http://www.SchplitZing.com" style="font-weight:bold;font-size:16px;line-height:20px;font-family:Georgia;" target="_blank">SchplitZing</a><br/>
		Migration
	</div></div>
	<div id="edit"><div id="main"><?php



$out = "";
if ($form){
	$out .= '<div class="edit_header standard edit_infos navigate">
				<div class="edit_tools">
					<button class="txtbutton install" data-form="infos_form" title="save">save</button>
				</div>
			</div>
			<div class="edit_half">';
	$out .= '<form id="infos_form" class="infoform" action="migrate.php" method="POST" enctype="multipart/form-data">';
		$out .= '<input type="hidden" name="identifier" value="'.$_POST['identifier'].'" />';
		$out .= '<input type="hidden" name="identifierpass" value="'.$_POST['identifierpass'].'" />';
		$out .= '<input type="hidden" name="origin" value="'.$origin.'" />';
	$out .= '<div class="whiteblock">';
		$out .= '<div class="formblock textblock"><div class="label">&nbsp;</div>Database</div>';
		$out .= '<div class="formblock textblock">
				<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_HOST">Host*</label></div>
					<input type="text" name="DB_HOST" class="formfield" value="'.$_POST['DB_HOST'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$port = (isset($_POST['DB_PORT']))? $_POST['DB_PORT'] : '8889';
		$out .= '" for="DB_PORT">Port*</label></div>
					<input type="text" name="DB_PORT" class="formfield" value="'.$port.'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_NAME">Database*</label></div>
					<input type="text" name="DB_NAME" class="formfield" value="'.$_POST['DB_NAME'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_USER">User*</label></div>
					<input type="text" name="DB_USER" class="formfield" value="'.$_POST['DB_USER'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_PASSWORD">Passwort*</label></div>
					<input type="text" name="DB_PASSWORD" class="formfield" value="'.$_POST['DB_PASSWORD'].'" />
				</div>';
	$out .= '</div>';
	$out .= '<div class="whiteblock">';
		$out .= '<div class="formblock textblock"><div class="label">&nbsp;</div><strong>Create User</strong></div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="author[firstname]">Firstname*</label></div>
					<input type="text" name="author[firstname]" class="formfield" value="'.$_POST['author']['firstname'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="author[name]">Name*</label></div>
					<input type="text" name="author[name]" class="formfield" value="'.$_POST['author']['name'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['user']['email'])){
			$out .= ($result['user']['email'])? ' label_invalid' : '';
		}
		$out .= '" for="email">Email*</label></div>
					<input type="text" name="email" class="formfield" value="'.$_POST['email'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['user']['username'])){
			$out .= ($result['user']['username'])? ' label_invalid' : '';
		}
		$out .= '" for="username">Username*</label></div>
					<input type="text" name="username" class="formfield" value="'.$_POST['username'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['user']['password'])){
			$out .= ($result['user']['password'])? ' label_invalid' : '';
		}
		$out .= '" for="password">Password*</label></div>
					<input type="text" name="password" class="formfield" value="'.$_POST['password'].'" />
				</div>';
	$out .= '</div>';
	$out .= '</form>';
} else {
	if (!isset($_GET['build'])){
		$out .= '<div class="edit_half">';
			$out .= '<div class="whiteblock info_text">';
				$out .= 'building';
			$out .= '</div>';
		$out .= '</div>';
	} else {
		$out .= '<div class="edit_half">';
			$out .= '<div class="whiteblock info_text">';
				$out .= 'Your SchplitZing is now installed and you can start adding content <a href="'.$origin.'">'.$articles->infos->title.'</a>.';
			$out .= '</div>';
		$out .= '</div>';
	}
}

echo $out;

function serializeProperties($array=array()){
	$result = false;
	foreach ($array as $field){
		if (isset($_POST[$field])){
			if (is_array($_POST[$field])){
				$result[$field] = serialize($_POST[$field]);
			} else {
				$result[$field] = utf8_decode($_POST[$field]);
			}
		}
	}
	return $result;
}

function isValidEmail($email){
	return eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email);
}

function isText($txt){
	$txt = stripslashes($txt);
	$txt = preg_replace( '/\s*/m', '', $txt);
	$l = levenshtein($txt, '<pclass="normal">&nbsp;</p>');
	$result = ($l > 4 || $l == -1)? true : false;
	return $result;
}

function install(){
	$origin = (strpos($_SERVER['HTTP_HOST'], 'http://') === false)? 'http://'.$_SERVER['HTTP_HOST'].str_replace("include/install/migrate.php", "", $_SERVER['PHP_SELF']) : $_SERVER['HTTP_HOST'].str_replace("include/install/migrate.php", "", $_SERVER['PHP_SELF']);
	$error = array('db'=>false,'createtable'=>array(),'insert'=>array(),'email'=>false,'config'=>false,'errorcode'=>false,'user'=>array());
	$sql['article'] = "CREATE TABLE IF NOT EXISTS sz_articles (
	  id int(10) NOT NULL AUTO_INCREMENT,
	  sort int(10) NOT NULL,
	  visibility tinyint(1) NOT NULL DEFAULT 1,
	  extern tinyint(1) NOT NULL DEFAULT 0,
	  field tinyint(1) NOT NULL,
	  title varchar(400) DEFAULT NULL,
	  lead text,
	  fragments varchar(200) DEFAULT NULL,
	  template varchar(10) NOT NULL,
	  extern_system varchar(32) NOT NULL,
	  extern_id int(10) DEFAULT NULL,
	  extern_url varchar(200) NOT NULL,
	  cache text NOT NULL,
	  author varchar(200) NOT NULL,
	  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  PRIMARY KEY (id)
	) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
	
	$sql['fragments'] = "CREATE TABLE IF NOT EXISTS sz_fragments (
	  id int(10) NOT NULL AUTO_INCREMENT,
	  type varchar(10) NOT NULL,
	  articles varchar(200) DEFAULT NULL,
	  tags tinyint(5) DEFAULT NULL,
	  title varchar(400) NOT NULL,
	  text text NOT NULL,
	  path varchar(200) DEFAULT NULL,
	  resource varchar(200) DEFAULT NULL,
	  thumb varchar(200) DEFAULT NULL,
	  size varchar(50) DEFAULT NULL,
	  html text,
	  source varchar(400) DEFAULT NULL,
	  source_url varchar(400) DEFAULT NULL,
	  author varchar(100) DEFAULT NULL,
	  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  PRIMARY KEY (id)
	) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
	
	$sql['infos'] = "CREATE TABLE IF NOT EXISTS sz_infos (
	  id int(1) NOT NULL AUTO_INCREMENT,
	  title varchar(500) NOT NULL,
	  subtitle varchar(500) NOT NULL,
	  description text NOT NULL,
	  screenshot varchar(200) DEFAULT NULL,
	  keywords text NOT NULL,
	  categories text NOT NULL,
	  startarticle TINYINT(5) NULL DEFAULT NULL,
	  author varchar(200) NOT NULL,
	  address varchar(500) NOT NULL,
	  language VARCHAR(4) NOT NULL DEFAULT 'en',
	  fields varchar(200) NOT NULL DEFAULT 'a:4:{i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";}',
	  identifier varchar(32) NOT NULL,
	  identifierpass varchar(13) NOT NULL,
	  connect int(1) NOT NULL DEFAULT 0,
	  last_connected DATETIME NOT NULL DEFAULT '2010-06-03 19:00:00',
	  public tinyint(1) NOT NULL DEFAULT 1,
	  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  PRIMARY KEY (id)
	) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
	
	$sql['relations'] = "CREATE TABLE IF NOT EXISTS sz_relations (
	  id int(10) NOT NULL AUTO_INCREMENT,
	  articleid int(10) NOT NULL,
	  relationid varchar(10) NOT NULL,
	  relationfield int(2) NOT NULL,
	  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  PRIMARY KEY (id)
	) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
	
	$sql['tags'] = "CREATE TABLE IF NOT EXISTS sz_tags (
	  id int(10) NOT NULL AUTO_INCREMENT,
	  tag varchar(300) NOT NULL,
	  description text NOT NULL,
	  author varchar(200) DEFAULT NULL,
	  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  PRIMARY KEY (id)
	) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
	
	$sql['user'] = "CREATE TABLE IF NOT EXISTS sz_user (
	  id int(10) NOT NULL AUTO_INCREMENT,
	  name varchar(50) NOT NULL,
	  username varchar(20) NOT NULL,
	  password varchar(30) NOT NULL,
	  type varchar(10) NOT NULL DEFAULT 'admin',
	  email varchar(100) NOT NULL,
	  last_login DATETIME NOT NULL,
	  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  PRIMARY KEY (id)
	) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
		
	$config = file('../config/config.inc.php');
	
	foreach ($config as $key=>$var){
		if (strstr($var, 'DOMAIN') != false && strstr($var, '// ') == false ) {
			$config[$key] = 'defined(\'DOMAIN\') ? null : define("DOMAIN", "'.$origin.'");'."\n";
		} else if (strstr($var, 'ROOT') != false && strstr($var, '// ') == false ){
			$config[$key] = 'defined(\'ROOT\') ? null : define("ROOT", "'.str_replace("include/install/migrate.php", "", $_SERVER['SCRIPT_FILENAME']).'");'."\n";
			define("NEWROOT", str_replace("include/install/migrate.php", "", $_SERVER['SCRIPT_FILENAME']));
		} else if (strstr($var, 'DB_HOST') != false && strstr($var, '// ') == false ){
			$db_host = (isset($_POST['DB_HOST']))? $_POST['DB_HOST'] : 'localhost';
			$config[$key] = 'defined(\'DB_HOST\') ? null : define("DB_HOST", "'.$db_host.'");'."\n";
		} else if (strstr($var, 'DB_NAME') != false && strstr($var, '// ') == false ){
			$db_name = (isset($_POST['DB_NAME']))? $_POST['DB_NAME'] : 'sz';
			$config[$key] = 'defined(\'DB_NAME\') ? null : define("DB_NAME", "'.$db_name.'");'."\n";
		} else if (strstr($var, 'DB_PORT') != false && strstr($var, '// ') == false ){
			$db_port = (isset($_POST['DB_PORT']))? $_POST['DB_PORT'] : '8889';
			$config[$key] = 'defined(\'DB_PORT\') ? null : define("DB_PORT", "'.$db_port.'");'."\n";
		} else if (strstr($var, 'DB_USER') != false && strstr($var, '// ') == false ){
			$db_user = (isset($_POST['DB_USER']))? $_POST['DB_USER'] : false;
			$config[$key] = 'defined(\'DB_USER\') ? null : define("DB_USER", "'.$db_user.'");'."\n";
		} else if (strstr($var, 'DB_PASSWORD') != false && strstr($var, '// ') == false ){
			$db_pass = (isset($_POST['DB_PASSWORD']))? $_POST['DB_PASSWORD'] : false;
			$config[$key] = 'defined(\'DB_PASSWORD\') ? null : define("DB_PASSWORD", "'.$db_pass.'");'."\n";
		}
	}
	
	$db;
	$host = $_POST['DB_HOST'];
	$port = $_POST['DB_PORT'];
	$name = $_POST['DB_NAME'];
	$username = $_POST['DB_USER'];
	$password = $_POST['DB_PASSWORD'];
	$old = array();
	
	if (isValidEmail($_POST['email']) && $_POST['username'] != '' && $_POST['password'] != ''){
		try {
			$db = new PDO("mysql:host=$host;port=$port;dbname=$name",$username,$password);
			$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
		} catch(PDOException $e) {
			$error['db'] = true;
			$error['errorcode'] = $e->getMessage();
		}
		
		if (is_object($db)){
			$installed_config = implode('', $config);
			$configfile = '../config/config.inc.php';
			$handle = fopen($configfile, 'w');
			fwrite($handle, $installed_config);
			fclose($handle);
			foreach ($sql as $key=>$table){
				$statement = $db->prepare($table);
				try {
					$statement->execute();
				} catch(PDOException $e) {
					$error['create'][$key] = $e->getMessage();
				}
			}
			$old['infos'] = fetchSql($db, "SELECT * FROM homepage LIMIT 1");
			if ($old['infos']){
				$old['infos'] = $old['infos'][0];
				$aut = explode(" ", $old['infos']->name);
				$oldauthor = array('firstname'=>$aut[0], 'name'=>$aut[1]);
				$author = $_POST['author'];
				$addr = splitString($old['infos']->adresse);
				$zipcity = explode(' ',$addr['ort']);
				if (count($zipcity) < 2){
					$zipcity = array(false, $addr['ort']);
				}
				$address = array('address01'=>$addr['strasse'], 'address02'=>'', 'address01'=>$addr['strasse'], 'zip'=>$zipcity[0], 'city'=>$zipcity[1], 'country'=>false, 'email'=>$_POST['email'], 'tel'=>$addr['tel']);
				$fi = splitString($old['infos']->kategorien);
				$field = array('1'=>$fi['a'], '2'=>$fi['b'], '3'=>$fi['c'], '4'=>$fi['d']);
				$properties['infos'] = array('title'=>$old['infos']->titel, 'subtitle'=>$old['infos']->untertitel, 'description'=>$old['infos']->beschreibung, 'screenshot'=>false, 'keywords'=>false, 'categories'=>false, 'author'=>serialize($author), 'address'=>serialize($address), 'fields'=>serialize($field), 'identifier'=>$_POST['identifier'], 'identifierpass'=>$_POST['identifierpass'], 'last_changed'=>$old['infos']->datum);
				$newinfos = create($db, 'sz_infos', $properties['infos']);
			}
			$old['user'] = fetchSql($db, "SELECT * FROM benutzer");
			$properties['user'] = array('name'=> utf8_decode(join(' ', $author)), 'username'=>$_POST['username'], 'password'=>$_POST['password'], 'type'=>'admin', 'email'=>$_POST['email']);
			$newuser = create($db, 'sz_user', $properties['user']);
			$old['articles'] = fetchSql($db, "SELECT * FROM artikel");
			$old['media'] = fetchSql($db, "SELECT * FROM medien WHERE id='image/jpg'");
			$relations = false;
			if ($old['articles']){
				foreach($old['articles'] as $k=>$a){
					$relations[$k]['relations'] = splitString($a->links);
					$relations[$k]['oldid'] = $a->ID;
					$properties['articles'][$k] = array('id'=>$a->ID, 'sort'=>$a->sortID, 'visibility'=>'1', 'extern'=>'0', 'field'=>false, 'title'=>$a->titel, 'lead'=>$a->lead, 'fragments'=>false, 'template'=>templateMigration($a->theme), 'extern_system'=>false, 'extern_id'=>false, 'extern_url'=>false, 'cache'=>false, 'author'=>$a->author, 'last_changed'=>$a->datum);
					if ($a->frame == 'a'){ $properties['articles'][$k]['field'] = '1'; } else if ($a->frame == 'b'){ $properties['articles'][$k]['field'] = '2'; } else if ($a->frame == 'c'){ $properties['articles'][$k]['field'] = '3'; } else if ($a->frame == 'd'){ $properties['articles'][$k]['field'] = '4'; }
					$relations[$k]['field'] = $properties['articles'][$k]['field'];
					$imgs = splitString($a->bilder);
					if ($a->theme == 'a') {
						$imgid = $imgs['1'];
						$img = fetchSql($db, "SELECT * FROM medien WHERE ID='$imgid'");
						if ($img){
							$img = $img[0];
							$image = copyImg($img->url, $img->art);
							if ($image){
								$fragments[$k][0] = array('type'=>'img', 'articles'=>false, 'tags'=>false, 'title'=>$img->name, 'text'=>false, 'path'=>$image['img'], 'resource'=>false, 'thumb'=>$image['thumbnail'], 'size'=>$image['aspect'], 'html'=>false, 'source'=>$img->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$img->datum);
								$fragments[$k][0]['tags'] = imgTag($db, $img->thema);
								$fragments[$k]['new'][0] = create($db, 'sz_fragments', $fragments[$k][0]);
							}
						}
						if(isText($a->text1)){
							$fragments[$k][1] = array('type'=>'text', 'articles'=>false, 'tags'=>false, 'title'=>$a->titel, 'text'=>$a->text1, 'path'=>false, 'resource'=>false, 'thumb'=>false, 'size'=>false, 'html'=>false, 'source'=>$a->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$a->datum);
							$fragments[$k]['new'][1] = create($db, 'sz_fragments', $fragments[$k][1]);
						}
					} else if ($a->theme == 'b'){
						$ik = 0;
						foreach($imgs as $im){
							$img = fetchSql($db, "SELECT * FROM medien WHERE ID='$im'");
							if ($img){
								$img = $img[0];
								if ($image = copyImg($img->url, $img->art)){
									$fragments[$k][$ik] = array('type'=>'img', 'articles'=>false, 'tags'=>false, 'title'=>$img->name, 'text'=>false, 'path'=>$image['img'], 'resource'=>false, 'thumb'=>$image['thumbnail'], 'size'=>$image['aspect'], 'html'=>false, 'source'=>$img->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$img->datum);
									$fragments[$k][$ik]['tags'] = imgTag($db, $img->thema);
									$fragments[$k]['new'][$ik] = create($db, 'sz_fragments', $fragments[$k][$ik]);
									$ik++;
								}
							}
						}
						if(isText($a->text1)){
							$fragments[$k][$ik] = array('type'=>'text', 'articles'=>false, 'tags'=>false, 'title'=>$a->titel, 'text'=>$a->text1, 'path'=>false, 'resource'=>false, 'thumb'=>false, 'size'=>false, 'html'=>false, 'source'=>$a->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$a->datum);
							$fragments[$k]['new'][$ik] = create($db, 'sz_fragments', $fragments[$k][$ik]);
						}
					} else if ($a->theme == 'c'){
						if(isText($a->text1)){
							$fragments[$k][0] = array('type'=>'text', 'articles'=>false, 'tags'=>false, 'title'=>$a->titel, 'text'=>$a->text1, 'path'=>false, 'resource'=>false, 'thumb'=>false, 'size'=>false, 'html'=>false, 'source'=>$a->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$a->datum);
							$fragments[$k]['new'][0] = create($db, 'sz_fragments', $fragments[$k][0]);
						}
						if(isText($a->text2)){
							$fragments[$k][2] = array('type'=>'text', 'articles'=>false, 'tags'=>false, 'title'=>$a->titel, 'text'=>$a->text2, 'path'=>false, 'resource'=>false, 'thumb'=>false, 'size'=>false, 'html'=>false, 'source'=>$a->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$a->datum);
							$fragments[$k]['new'][2] = create($db, 'sz_fragments', $fragments[$k][2]);
						}
						$ik = 1;
						foreach($imgs as $im){
							$img = fetchSql($db, "SELECT * FROM medien WHERE ID='$im'");
							if ($img){
								$img = $img[0];
								if ($image = copyImg($img->url, $img->art)){
									$fragments[$k][$ik] = array('type'=>'img', 'articles'=>false, 'tags'=>false, 'title'=>$img->name, 'text'=>false, 'path'=>$image['img'], 'resource'=>false, 'thumb'=>$image['thumbnail'], 'size'=>$image['aspect'], 'html'=>false, 'source'=>$img->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$img->datum);
									$fragments[$k][$ik]['tags'] = imgTag($db, $img->thema);
									$fragments[$k]['new'][$ik] = create($db, 'sz_fragments', $fragments[$k][$ik]);
									$ik++; $ik++;
								}
							}
						}
						$fragments[$k]['new'] = array_values($fragments[$k]['new']);
					} else if ($a->theme == 'd'){
						$fragments[$k][0] = array('type'=>'text', 'articles'=>false, 'tags'=>false, 'title'=>$a->titel, 'text'=>$a->text1, 'path'=>false, 'resource'=>false, 'thumb'=>false, 'size'=>false, 'html'=>false, 'source'=>$a->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$a->datum);
						$fragments[$k]['new'][0] = create($db, 'sz_fragments', $fragments[$k][0]);
					} else if ($a->theme == 'e'){
						$properties['articles'][$k]['visibility'] = '3';
						$fragments[$k][0] = array('type'=>'headline', 'articles'=>false, 'tags'=>false, 'title'=>$a->titel, 'text'=>$a->headline, 'path'=>false, 'resource'=>false, 'thumb'=>false, 'size'=>false, 'html'=>false, 'source'=>$a->quelle, 'source_url'=>false, 'author'=>$a->author, 'last_changed'=>$a->datum);
						$fragments[$k]['new'][0] = create($db, 'sz_fragments', $fragments[$k][0]);
					} else if ($a->theme == 'f'){
						$vid = fetchSql($db, "SELECT * FROM medien WHERE ID='$a->video'");
						if ($vid){
							$vid = $vid[0];
							if ($video = createVideo($vid->url)){
								$fragments[$k][0] = array('type'=>'video', 'articles'=>false, 'tags'=>false, 'title'=>$vid->name, 'text'=>$video['text'], 'path'=>$video['path'], 'resource'=>'vimeo', 'thumb'=>$video['thumbnail'], 'size'=>false, 'html'=>$video['html'], 'source'=>$video['source'], 'source_url'=>$video['source_url'], 'author'=>$a->author, 'last_changed'=>$a->datum);
								$fragments[$k]['new'][0] = create($db, 'sz_fragments', $fragments[$k][0]);
							}
						}
					}
					$properties['articles'][$k]['fragments'] = serialize($fragments[$k]['new']);
					$relations[$k]['id'] = create($db, 'sz_articles', $properties['articles'][$k]);
				}
			}
			if ($relations){
				foreach($relations as $rk=>$rel){
					foreach($rel['relations'] as $rf=>$r){
						if ($rf == 'a' && $rel['field'] != '1'){
							$relfield = '1';
							if ($r != 'e' && $r != 'w'){
								foreach($old['articles'] as $ak=>$ar){
									if($r == $ar->ID){
										$relid = ($relations[$ak]['id'] != $rel['id'])? $relations[$ak]['id'] : 'e';
									}
								}
							} else {
								$relid = $r;
							}
							$properties['relations'][$k][$relfield] = array('articleid'=>$rel['id'], 'relationid'=>$relid, 'relationfield'=>$relfield);
							$properties['relations'][$k]['created'][$relfield] = create($db, 'sz_relations', $properties['relations'][$k][$relfield]);
						} else if ($rf == 'b' && $rel['field'] != '2'){
							$relfield = '2';
							if ($r != 'e' && $r != 'w'){
								foreach($old['articles'] as $ak=>$ar){
									if($r == $ar->ID){
										$relid = ($relations[$ak]['id'] != $rel['id'])? $relations[$ak]['id'] : 'e';
									}
								}
							} else {
								$relid = $r;
							}
							$properties['relations'][$k][$relfield] = array('articleid'=>$rel['id'], 'relationid'=>$relid, 'relationfield'=>$relfield);
							$properties['relations'][$k]['created'][$relfield] = create($db, 'sz_relations', $properties['relations'][$k][$relfield]);
						} else if ($rf == 'c' && $rel['field'] != '3'){
							$relfield = '3';
							if ($r != 'e' && $r != 'w'){
								foreach($old['articles'] as $ak=>$ar){
									if($r == $ar->ID){
										$relid = ($relations[$ak]['id'] != $rel['id'])? $relations[$ak]['id'] : 'e';
									}
								}
							} else {
								$relid = $r;
							}
							$properties['relations'][$k][$relfield] = array('articleid'=>$rel['id'], 'relationid'=>$relid, 'relationfield'=>$relfield);
							$properties['relations'][$k]['created'][$relfield] = create($db, 'sz_relations', $properties['relations'][$k][$relfield]);
						} else if ($rf == 'd' && $rel['field'] != '4'){
							$relfield = '4';
							if ($r != 'e' && $r != 'w'){
								foreach($old['articles'] as $ak=>$ar){
									if($r == $ar->ID){
										$relid = ($relations[$ak]['id'] != $rel['id'])? $relations[$ak]['id'] : 'e';
									}
								}
							} else {
								$relid = $r;
							}
							$properties['relations'][$k][$relfield] = array('articleid'=>$rel['id'], 'relationid'=>$relid, 'relationfield'=>$relfield);
							$properties['relations'][$k]['created'][$relfield] = create($db, 'sz_relations', $properties['relations'][$k][$relfield]);
						} 
						
					}
					
				}
			}
			if (is_array($old['media'])){
				foreach($old['articles'] as $k=>$m){
					if (!isImgFragment($fragments, $m->url)){
						if ($image = copyImg($m->url, $m->art)){
							$fragments['u'][$k] = array('type'=>'img', 'articles'=>false, 'tags'=>false, 'title'=>$m->name, 'text'=>false, 'path'=>$image['img'], 'resource'=>false, 'thumb'=>$image['thumbnail'], 'size'=>$image['aspect'], 'html'=>false, 'source'=>$m->quelle, 'source_url'=>false, 'author'=>join(" ", $author), 'last_changed'=>$m->datum);
							$fragments['u'][$k]['tags'] = imgTag($db, $m->thema);
							$fragments['u']['new'][$k] = create($db, 'sz_fragments', $fragments['u'][$k]);
						}
					}
				}
			}
			$db->exec("DROP TABLE artikel");
			$db->exec("DROP TABLE benutzer");
			$db->exec("DROP TABLE homepage");
			$db->exec("DROP TABLE medien");
			rrmdir(NEWROOT.'bild');
			rrmdir(NEWROOT.'css');
			rrmdir(NEWROOT.'img');
			rrmdir(NEWROOT.'scripts');
			unlink(NEWROOT.'felder.php');
			unlink(NEWROOT.'header.php');
			unlink(NEWROOT.'menulist.php');
			unlink(NEWROOT.'metainfo.php');
		} else {
			$error['db'] = true;
		}
	} else {
		if ($_POST['username'] == ''){
			$error['user']['username'] = true;
		}
		if ($_POST['password'] == ''){
			$error['user']['password'] = true;
		}
		if (!isValidEmail($_POST['email'])){
			$error['user']['email'] = true;
		}
	}	
	return $error;
}

function fetchSql($db, $sql="",$vals=null) {
	if (is_object($db)){
		try {
			$statement = $db->prepare($sql);
			$statement->execute($vals);
			$rows = $statement->fetchALL(PDO::FETCH_OBJ);
			if(count($db->errorInfo()) > 1) {
				
			}
			$result = (count($rows) > 0) ? $rows : false;
			return $result;
		} catch(PDOException $e) {
			return false;
		}
	}
}

function create($db, $table, $properties){
	if (is_object($db)){
		$sql = "INSERT INTO " . $table . " (";
		$sql .= join(", ", array_keys($properties));
		$sql .= ") VALUES (";
		$c = count($properties); $i = 1;
		foreach ($properties as $value){
			$sql .= ($i < $c)? $db->quote($value).', ' : $db->quote($value);
			$i++;
		}
		$sql .= ")";
		$statement = $db->prepare($sql);
		try {
			$statement->execute();
			return $db->lastInsertId();
		} catch(PDOException $e) {
			return false;
		}
	}
}

function splitString($string){
	$string = explode(";", $string);
	$result = false;
	foreach ($string as $a) {
		$b = explode(":", $a);
		if (isset($b[1])){
			$result[$b[0]] = utf8_encode($b[1]);
		}
	}
	return $result;
}

function imgTag($db, $tag){
	if ($tag){
		$t = fetchSql($db, "SELECT * FROM sz_tags WHERE tag=".$db->quote($tag)."");
		if ($t){
			return $t[0]->id;
		} else {
			return create($db, 'sz_tags', array('tag'=>$tag));
		}
	} else {
		return false;
	}
}
function isImgFragment($fragments, $img){
	if(is_array($fragments)){
		foreach($fragments as $k=>$fr){
			if (is_array($fr)){
				foreach($fr as $f){
					if ('bild/'.$f->path == $img){
						return true;
					}
				}
			} else {
				if ('bild/'.$f->path == $img){
					return true;
				}
			}
		}
	}
	return false;
}

function copyImg($img, $type){
	$result = false;
	if (file_exists(NEWROOT.$img)){
		$newname = str_replace("bild/", "", $img);
		if (copy(NEWROOT.$img, NEWROOT.MEDIA_PATH.$newname)) {
	  		unlink(NEWROOT.$img);
	  		$thumb_name = 'thumb_'.$newname;
	  		$ext = strtolower(strrchr($newname,'.'));
	  		$type = ($ext == '.gif' && $type != 'image/gif')? 'image/gif' : $type;
	  		$type = ($ext == '.png' && $type != 'image/x-png' && $type != 'image/png')? 'image/png' : $type;
	  		if($type == "image/jpg" || $type == "image/jpeg" || $type == "image/pjpeg"){
		    	$new_img = imagecreatefromjpeg(NEWROOT.MEDIA_PATH.$newname);
		   	} else if ($type == "image/x-png" || $type == "image/png"){
		    	$new_img = imagecreatefrompng(NEWROOT.MEDIA_PATH.$newname);
			} else if($type == "image/gif"){
		    	$new_img = imagecreatefromgif(NEWROOT.MEDIA_PATH.$newname);
			}
			list($width, $height) = getimagesize(NEWROOT.MEDIA_PATH.$newname);
			$imgratio=$width/$height;
			if ($imgratio>1){
				$thumbwidth = THUMB_SIZE;
				$thumbheight = round(THUMB_SIZE/$imgratio);
			} else {
				$thumbheight = THUMB_SIZE;
				$thumbwidth = round(THUMB_SIZE*$imgratio);
			}
			if (function_exists("imagecreatetruecolor")){
				$resized_thumb = imagecreatetruecolor($thumbwidth,$thumbheight);
				imagecopyresampled($resized_thumb, $new_img, 0, 0, 0, 0, $thumbwidth, $thumbheight, $width, $height);
				if ( imagejpeg ($resized_thumb, NEWROOT.MEDIA_PATH.$thumb_name, 80) ){
					$result['img'] = $newname;
					$result['thumbnail'] = $thumb_name;
					$result['aspect'] = $imgratio;
				}
			}
		}
	}
	return $result;
}

function createVideo($resource){
	$result = false;
	$resource = (stripos($resource, "http://www.vimeo.com/") === false) ? "http://www.vimeo.com/".$resource : $resource;
	$json_url = VIMEO_ENDPOINT . '.json?url=' . rawurlencode($resource) . '&width=' . VIDEO_WIDTH . '&height=' . VIDEO_HEIGHT . '&portrait=false&byline=false&api=true';
	$video = json_decode(curl_get($json_url));
	if (isset($video->video_id)){
		$sizes = 'width="'.VIDEO_WIDTH.'" height="'.VIDEO_HEIGHT.'"';
		$video->html = str_replace($sizes, 'width="100%" height="100%"', $video->html);
		$result['html'] = $video->html;
		$result['path'] = $resource;
		$result['thumbnail'] = (isset($video->thumbnail_url)) ? $video->thumbnail_url : NULL;
		$result['source'] = $video->author_name;
		$result['source_url'] = $video->author_url;
		$result['text'] = (isset($video->description)) ? $video->description : NULL;
	}
	return $result;
}

function templateMigration($id){
	$result = false;
	if ($id == 'a'){
		$result = 'image';
	} else if ($id == 'b'){
		$result = 'images';
	} else if ($id == 'c'){
		$result = 'blog';
	} else if ($id == 'd'){
		$result = 'text';
	} else if ($id == 'e'){
		$result = 'headline';
	} else if ($id == 'f'){
		$result = 'video';
	}
	return $result;
}

function rrmdir($dir) { 
	if (is_dir($dir)) { 
		$objects = scandir($dir); 
		foreach ($objects as $object) { 
			if ($object != "." && $object != "..") { 
				if (filetype($dir."/".$object) == "dir") rrmdir($dir."/".$object); else unlink($dir."/".$object); 
			}
		} 
		reset($objects); 
		rmdir($dir); 
	} 
}

function mysqlDump($db, $file){
	if (is_object($db)){
		
	}
}

?>

			
		</div>
	</div>
	<script type="text/javascript" src="../public/js/jquery-1.7.1.min.js"></script>
	<script type="text/javascript" src="../private/js/jquery.form.js"></script>
	<script type="text/javascript">
	
		$(function(){
		
			<?php if (!$form && !isset($_GET['build'])): ?>
				var data = {
					task : 'login',
					uid : '<?= $_POST['username'] ?>',
					pwd : '<?= $_POST['password'] ?>'
				}
				$.post('<?= $origin ?>index.php', data, function(d){
					console.log(d);
					window.location="<?= $origin ?>include/install/migrate.php?build=1";
				});
			<?php else: ?>
				$('button.install').click(function(){
					if(validate()){
						data = {
							title : 'migrated',
							author : {
								firstname : $('input[name="author[firstname]"]').val(),
								name : $('input[name="author[name]"]').val()
							},
							address : {
								address01 : '',
								address02 : '',
								zip : '',
								city : '',
								country : '',
								email : $('input[name="email"]').val(),
								tel : ''
							},
							origin : '<?= $origin ?>'
						};
						if ($('input[name="identifier"]').val()){
							$('#infos_form').submit();
						} else {
							$.ajax({
							  	type : 		'POST',
							  	url: 		"http://connect.schplitzing.com/activate.php?task=create",
							  	data : 		data,
							  	success : 	function(dat, textStatus, jqXHR){
							  					$('input[name="identifier"]').val(dat.id);
												$('input[name="identifierpass"]').val(dat.task);
												$('#infos_form').submit();
								},
								error :		function(jqXHR, textStatus, errorThrown){
												if(confirm('Connection to central SchplitZing could not be established.\nYou can still install your SchplitZing and connect it later.')){
													$('#infos_form').submit();
												}
								},
								dataType : 	'json'
							});
						}
					}
					
				});
			<?php endif; ?>
			
			
		
		});
		
		function validate(){
			var result = true;
			if ($('input[name="author[firstname]"]').val().length < 3){
				$('label[for="author[firstname]"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="author[firstname]"]').css({'color':'#000'});
			}
			if ($('input[name="author[name]"]').val().length < 3){
				$('label[for="author[name]"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="author[name]"]').css({'color':'#000'});
			}
			var email = $('input[name="email"]').val();
			var emailfilter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
			if(!emailfilter.test(email)){
				$('label[for="email"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="email"]').css({'color':'#000'});
			}
			if ($('input[name="DB_HOST"]').val().length < 1){
				$('label[for="DB_HOST"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="DB_HOST"]').css({'color':'#000'});
			}
			if ($('input[name="DB_NAME"]').val().length < 1){
				$('label[for="DB_NAME"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="DB_NAME"]').css({'color':'#000'});
			}
			if ($('input[name="DB_USER"]').val().length < 1){
				$('label[for="DB_USER"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="DB_USER"]').css({'color':'#000'});
			}
			if ($('input[name="DB_PASSWORD"]').val().length < 1){
				$('label[for="DB_PASSWORD"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="DB_PASSWORD"]').css({'color':'#000'});
			}
			var username = $('input[name="username"]').val();
			var userfilter = /\S+/;
			if(!userfilter.test(username)){
				$('label[for="username"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="username"]').css({'color':'#000'});
			}
			if ($('input[name="password"]').val().length < 1){
				$('label[for="password"]').css({'color':'red'});
				result = false;
			} else {
				$('label[for="password"]').css({'color':'#000'});
			}
			return result;
		}
	
	</script>
</body>
</html>