$(function(){
			
	$('button.install').click(function(){
	
		var validation = validate();
		
		if (validation){
			data = {
				author: {},
				address: {}
			};
			$('input, textarea').each(function(){
				var key = $(this).attr('name');
				var val = $(this).val();
				if (key && key != 'username' && key != 'password' && key != 'DB_HOST' && key != 'DB_NAME' && key != 'DB_USER' && key != 'DB_PASSWORD' && key != 'identifier' && key != 'identifierpass'){
					if (key.search(/\[.+/) == -1){
						data[key] = val;
					} else {
						var subkey = key.match(/\[(.*?)\]/)[1];
						key = key.match(/(.+)\[/)[1];
						data[key][subkey] = val;
					}
				}
			});
			if ($('input[name="identifier"]').val()){
				$('#infos_form').submit();
			} else {
				$.ajax({
				  	type : 		'POST',
				  	url: 		"http://connect.schplitzing.com/activate.php?task=create",
				  	data : 		data,
				  	success : 	function(dat, textStatus, jqXHR){
									$('input[name="identifier"]').val(dat.id);
									$('input[name="identifierpass"]').val(dat.task);
									$('#infos_form').submit();
					},
					error :		function(jqXHR, textStatus, errorThrown){
									if(confirm('Connection to central SchplitZing could not be established.\nYou can still install your SchplitZing and connect it later.')){
										$('#infos_form').submit();
									}
									console.log(textStatus);
					},
					dataType : 	'json'
				});
			}
		}
	
	});

});

function validate(){
	var result = true;
	if ($('input[name="title"]').val().length < 1){
		$('label[for="title"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="title"]').css({'color':'#000'});
	}
	if ($('input[name="author[firstname]"]').val().length < 3){
		$('label[for="author[firstname]"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="author[firstname]"]').css({'color':'#000'});
	}
	if ($('input[name="author[name]"]').val().length < 3){
		$('label[for="author[name]"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="author[name]"]').css({'color':'#000'});
	}
	var email = $('input[name="address[email]"]').val();
	var emailfilter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	if(!emailfilter.test(email)){
		$('label[for="address[email]"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="address[email]"]').css({'color':'#000'});
	}
	if ($('input[name="DB_HOST"]').val().length < 1){
		$('label[for="DB_HOST"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="DB_HOST"]').css({'color':'#000'});
	}
	if ($('input[name="DB_NAME"]').val().length < 1){
		$('label[for="DB_NAME"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="DB_NAME"]').css({'color':'#000'});
	}
	if ($('input[name="DB_USER"]').val().length < 1){
		$('label[for="DB_USER"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="DB_USER"]').css({'color':'#000'});
	}
	if ($('input[name="DB_PASSWORD"]').val().length < 1){
		$('label[for="DB_PASSWORD"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="DB_PASSWORD"]').css({'color':'#000'});
	}
	var username = $('input[name="username"]').val();
	var userfilter = /\S+/;
	if(!userfilter.test(username)){
		$('label[for="username"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="username"]').css({'color':'#000'});
	}
	if ($('input[name="password"]').val().length < 1){
		$('label[for="password"]').css({'color':'red'});
		result = false;
	} else {
		$('label[for="password"]').css({'color':'#000'});
	}
	return result;
}