<?php
/*
------------------
Language: English
------------------
*/

$lang = array();

$langcode = array(
	'en'=>'English',
	'de'=>'German'
);

// ADMIN

$lang['NOT_CONFIGURED'] = "Your SchplitZing doesn't seem to be correctly configured";
$lang['BOOKMARKLET'] = 'bookmarklet';
$lang['BOOKMARKLET_HELP'] = 'drag this link to your bookmarkbar in your browser';
$lang['OR'] = 'or';
$lang['TRY_CONNECT'] = 'Your SchplitZing is not yet connected with the central database. Click here to establish the connection and share your articles with other SchplitZing-authors.';
$lang['BUTTON_CONNECT'] = 'connect';

// MENU

$lang['SETTINGS'] = 'Settings';
$lang['USER'] = 'User';
$lang['TAGS'] = 'Tags';
$lang['FRAGMENTS'] = 'Fragments';
$lang['ARTICLES'] = 'Articles';
$lang['RELATIONS'] = 'Relations';
$lang['CONTENT_RELATIONS'] = 'Content and Relations';
$lang['SCHPLITZING'] = 'SchplitZing';
$lang['FRONT'] = 'SchplitZing';
$lang['ABOUT'] = 'About';
$lang['CONTENT'] = 'Edit';
$lang['NETWORK'] = 'Network';
$lang['SHOWABOUT'] = 'more';
$lang['SHOW_RELATIONS'] = 'show relations';
$lang['SHOW_CONTENT'] = 'show content';
$lang['COMPOSE'] = 'compose article';

// BUTTONS

$lang['LOGIN'] = 'login';
$lang['LOGOUT'] = 'logout';
$lang['SAVE'] = 'save';
$lang['CANCEL'] = 'cancel';
$lang['EDIT'] = 'edit';
$lang['DELETE'] = 'delete';
$lang['ADD'] = 'add';
$lang['NEW'] = 'new';
$lang['REMOVE'] = 'remove';
$lang['SORT_BY'] = 'sort by';
$lang['SORT_TAGS'] = 'tags';
$lang['SORT_TYPE'] = 'type';
$lang['SORT_DATE'] = 'date';
$lang['SZ_EXTERN'] = 'extern';
$lang['SZ_CONNECTIONS'] = 'connections';
$lang['SZ_RELATIONS'] = 'relations';

// FORMS

$lang['TITLE'] = 'Title';
$lang['SUBTITLE'] = 'Subtitle';
$lang['DESCRIPTION'] = 'Description';
$lang['KEYWORDS'] = 'Keywords';
$lang['FIRST_NAME'] = 'First Name';
$lang['LAST_NAME'] = 'Name';
$lang['ADDRESS_01'] = 'Address';
$lang['ADDRESS_02'] = 'Address';
$lang['ZIP'] = 'Zip';
$lang['CITY'] = 'City';
$lang['COUNTRY'] = 'Country';
$lang['EMAIL'] = 'Email';
$lang['TELEPHONE'] = 'Tel';
$lang['FIELDS'] = 'Fields';
$lang['FIELD'] = 'Field';
$lang['AUTHOR'] = 'Author';
$lang['COLLABORATORS'] = 'Collaborators';
$lang['LINK'] = 'Link';
$lang['LANGUAGE'] = 'Language';
$lang['LOGIN_TEXT'] = 'only for Author and Collaborators';

$lang['NAME'] = 'Name';
$lang['USERNAME'] = 'Username';
$lang['PASSWORD'] = 'Password';
$lang['PASSWORD_REPEAT'] = 'Password';
$lang['USERTYPE'] = 'Type';

$lang['TAG'] = 'Tag';
$lang['TAG_DESCRIPTION'] = 'Description';
$lang['NOT_TAGGED'] = 'not tagged';
$lang['ADD_TAG'] = 'add tag';

$lang['SOURCE'] = 'Source';
$lang['SOURCE_URL'] = 'Source URL';
$lang['VIDEO_SOURCE'] = 'Source';
$lang['URL_OR_ID'] = 'ID or URL';
$lang['REPLACE_IMAGE'] = 'replace image';
$lang['REPLACE_VIDEO'] = 'replace video';
$lang['VIMEO'] = 'Vimeo';
$lang['YOUTUBE'] = 'YouTube';
$lang['SOUNDCLOUD'] = 'SoundCloud';

$lang['FRAGMENT'] = 'Fragment';
$lang['NEW_FRAGMENT'] = 'new';
$lang['ADD_FRAGMENT'] = 'Add Fragment';
$lang['DROP_FRAGMENT'] = 'Drop Fragment here';
$lang['ADD_FRAGMENT_OF_TYPE'] = 'Add Fragment of type';
$lang['FRAGMENT_USED'] = 'Fragment is used in Articles:';
$lang['DELETE_ANYWAY'] = 'Delete anyway?';

$lang['ARTICLE'] = 'Article';
$lang['TEMPLATE'] = 'Template';
$lang['VISIBILITY'] = 'Visibility';
$lang['VISIBILITY_ARTICLE'] = 'in Article';
$lang['VISIBILITY_MENU'] = 'in Menu';
$lang['LEAD'] = 'Lead';

$lang['ADD_ARTICLE'] = 'add article';
$lang['CHECK_RELATIONS'] = 'check relations';
$lang['SAVE_RELATIONS'] = 'save relations';
$lang['WHITE_ARTICLE'] = 'white';
$lang['NOT_RELATED'] = 'not related';

$lang['SCREENSHOT'] = 'screenshot';
$lang['CREATE_SCREENSHOT'] = 'create screenshot';
$lang['UPLOAD_SCREENSHOT'] = 'upload screenshot';
$lang['CHOOSE_ARTICLE'] = 'article';

// SCHPLITZING

$lang['SEARCH'] = 'search';
$lang['TITLE_EXTERNAL'] = 'external Articles';
$lang['TITLE_SEARCH'] = 'search in SchplitZing Library';
$lang['SEARCH_BY'] = 'Search by';
$lang['SEARCH_BY_AUTHOR'] = 'Author';
$lang['SEARCH_BY_URL'] = 'URL';
$lang['SEARCH_BY_TITLE'] = 'Title';
$lang['SEARCH_BY_FULLTEXT'] = 'Fulltext';
$lang['NO_EXTERNAL'] = 'No external Articles in this SchplitZing';
$lang['SEARCH_IN'] = 'Search in';
$lang['SEARCH_IN_SYSTEM'] = 'SchplitZings';
$lang['SEARCH_IN_ARTICLES'] = 'Articles';
$lang['SEARCH_IN_ALL'] = 'all';
$lang['SEARCH_TERM'] = 'Search for';
$lang['RESULT'] = 'Result';
$lang['PREVIEW'] = 'Preview';
$lang['PREVIEW_ARTICLE'] = 'Article';
$lang['PREVIEW_RELATIONS'] = 'Relations';
$lang['CONNECTIONS_NEW'] = 'Connections';
$lang['RELATIONS_NEW'] = 'Relations to Articles in your SchplitZing';
$lang['CONNECTION_TITLE'] = 'Connection';
$lang['CONNECTION_SCHPLITZING'] = 'SchplitZing';
$lang['CONNECTION_ARTICLES'] = 'Articles from you connected to this SchplitZing';
$lang['ARTICLE_OFFLINE'] = 'Offline';
$lang['ABOUT_SCHPLITZING'] = 'about SchplitZing';

?>