(function( $ ){

	var methods = {
    	init : function( options ) {
    		if ( options ) { 
        		$.extend( $.fn.admin.defaults, options );
      		}
      		opt = $.fn.admin.defaults;
      		$this = $(this);
      		f.help();
      		f.setvars($this);
      	},
      	settings : function( options ) {
    		if ( options ) { 
        		$.extend( $.fn.admin.defaults, options );
      		}
      		$.fn.admin.defaults.method = 'settings';
      		opt = $.fn.admin.defaults;
      		$this = $(this);
      		f.setvars($this);
      		f.schplitZingCheckConnection($this);
      		f.schplitZingUpdateConnections($this);
      		f.logout($this);
      		f.submenu('edit_hidden');
    		f.help();
    		f.saving();
      		f.cancel($this, function(form){
      			f.loaded();
      			if (form.data('struct') == 'users'){
      				if (form.find('input[name="id"]').val() == '0'){
      					form.prev('.form_tools').remove();
      					form.remove();
      				} else {
      					form.prev('.form_tools').addClass('collapsed');
      				}
      			}
      		});
      		$('button.edit').unbind('click').bind('click', function(){
      			$(this).parents('.form_tools').removeClass('collapsed');
      		});
      		f.add($this, 'button.plus', function(){
  				if ($('#users_form_0').size() > 0){
  					return false;
  				} else {
  					return true;
  				}
  			}, '.edit_half.edit_users', { struct : 'users', form : '1', tools : '1' }, function(){
      			$('#users_form_0').prev('.users_tools').removeClass('collapsed');
      			$this.admin(opt.method);
      		});
      		$('button.save').unbind('click').bind('click', function(){
      			var form = $('#'+$(this).data('form')); var btn = $(this);
      			if ( form.data('struct') == 'users') { var required = ['username', 'email', 'password'] } else { var required = false; }
      			if (opt.debug) { console.log('save'); }
      			f.form($this, form, function(data, status, xhr, fm){
      				if (data.lastId && form.data('struct') == 'users'){
      					var tools = form.prev('.form_tools');
      					tools.find('button').data('form', form.data('struct')+'_form_'+data.lastId);
      					tools.addClass('collapsed');
      					form.data('key', data.lastId).find('input[name="id"]').val(data.lastId);
      					form.attr('id', form.data('struct')+'_form_'+data.lastId);
      				} else if (form.data('struct') == 'users'){
      					form.prev('.form_tools').addClass('collapsed');
      				}
      				if (form.data('struct') == 'infos'){
      					f.schplitZingConnect($this, form.data('struct'), f.schplitZingGatherData($this, form, 'save'), function(d){ f.loaded(btn); if(opt.debug){ console.log(d); } }, function(d){ f.loaded(btn); if(opt.debug){ console.log(d); }});
      				}
      				
      			}, function(formData, jqForm, options){
      				var result = true;
      				if (jqForm.data('struct') == 'users'){
	      				if (jqForm[0].password.value != jqForm[0].rtpassword.value){
					    	jqForm.find('label[for="rtpassword"]').addClass('alert');
					    	result = false;
					    }
					}
					return result;
      			}, required);
      		});
      		f.del($this, 'button.delete', true, false, function(){
      			return confirm('Delete User?');
      		}, function(form, data){
      			f.loaded();
      			if (data.status){
      				form.prev('.form_tools').remove();
      				form.remove();
      			}
      		});
      		f.bindChanges($this, $('.infos_form'), { title : $('#header .header_title'), subtitle : $('#header .header_subtitle') });
      		f.bindChanges($this, $('.users_form'), { name : '.form_tools_title'});
      		$('.button_screenshot').unbind('click').bind('click', function(){
      			var button = $(this);
      			if (opt.debug){ console.log('screenshot '+$(this).data('screenshot')) }
      			f.loading();
      			if(opt.screenshot){
      				if (button.data('screenshot') == 'create'){
      					$.post(opt.adminpath, { form : 'screenshot', task : 'listtitles' }, function(d) {
							$('.edit_half.edit_screenshot').screenshot('init',{articles : d, adminpath : opt.adminpath });
						}, 'json');
      				} else if (button.data('screenshot') == 'upload'){
      					$('.edit_half.edit_screenshot').screenshot('upload',{adminpath : opt.adminpath });
      					f.loaded();
      				}
      			} else {
      				$.getScript(opt.scriptpath+'jquery.screenshot.js', function(){
      					if (opt.debug){ console.log('screenshot get script') }
						if (button.data('screenshot') == 'create'){
	      					$.post(opt.adminpath, { form : 'screenshot', task : 'listtitles' }, function(d) {
	      						if (opt.debug){ console.log('articlelist', d); }
								$('.edit_half.edit_screenshot').screenshot('init', {articles : d, adminpath : opt.adminpath });
							}, 'json');
	      				} else if (button.data('screenshot') == 'upload'){
	      					f.loaded();
	      					$('.edit_half.edit_screenshot').screenshot('upload',{adminpath : opt.adminpath });
	      				}
					});
      			}
      		});
      	},
    	content : function( options ) {
    		if ( options ) { 
        		$.extend( $.fn.admin.defaults, options );
      		}
      		$.fn.admin.defaults.method = 'content';
      		opt = $.fn.admin.defaults;
      		$this = $(this);
      		f.setvars($this);
      		f.schplitZingCheckConnection($this);
      		f.logout($this);
      		f.help();
      		f.initJscrollpane($this, '.field_container', 'field', function(pane, jsp){
      			$this.admin.defaults.current[pane.data('field')] = false;
      			pane.bind('jsp-scroll-y', function(event, scrollPositionY, isAtBottom, isAtTop){
      				$(this).find('.video').removeClass('playing');
					var art = f.getCurrentArticle($(this), scrollPositionY); var field = $(this).data('field'); var id = art.data('id');
					if (isNaN(id)){ id = id.substring(0,1); }
					if ($this.admin.defaults.current[field] != id){
						$this.admin.defaults.current[field] = id;
						$('#m'+field+' .menu_list_item').removeClass('active');
						$('#menu_list_item_'+id).addClass('active');
					}
      			});
      		});
      		f.sortableArticles($this, '.relationslist', 'li.listed_article', '.article_title', function(event, ui){
      			return ui.addClass('sorting').clone();
      		}, function(event, ui){
      			ui.item.removeClass('sorting');
      		});
      		f.loadImages($this);
      		f.loadExternalArticles($this);
      		$('.submenu_button').unbind('click').bind('click', function(){
      			$('.submenu_button').removeClass('show'); $(this).addClass('show');
      			$('.menu, .edit_header, .relationslist, .content_buttons').removeClass('content relations');
      			$('.menu, .edit_header, .relationslist, .content_buttons').addClass($(this).data('editor'));
      			f.reinitJscrollpane($this);
      			window.location.hash = $(this).data('editor');
      		});
      		if (window.location.hash){
				var navigate = window.location.hash;
				$('.submenu_button').each(function(){
					if ('#'+$(this).data('editor') == navigate){
						$('.submenu_button').removeClass('show'); $(this).addClass('show');
      					$('.menu, .edit_header, .relationslist, .content_buttons').removeClass('content relations');
      					$('.menu, .edit_header, .relationslist, .content_buttons').addClass($(this).data('editor'));
      					f.reinitJscrollpane($this);
					}
				})
			}
      		$('.menu_list_item').unbind('click').bind('click', function(){
      			var field = $(this).parent('.menu_list').data('field');
      			opt.jscrollpanes[field].scrollToElement($('#'+$(this).data('id')), true, true);
      		});
      		$('button.checkrelations').unbind('click').bind('click', function(){
      			f.scrollToRelations($this, $(this).data('field'));
      		});
      		$('button.saverelations').unbind('click').bind('click', function(){
      			f.saveRelations($this, $(this).data('field'));
      		});
      		$('button.edit').unbind('click').bind('click', function(){
      			location.href = 'index.php?struct=fragments&id='+$(this).data('id');
      		});
      		$('button.plus').unbind('click').bind('click', function(){
      			location.href = 'index.php?struct=fragments&id=0&sort='+$(this).data('next')+'&field='+$(this).data('field');
      		});
      		f.del($this, 'button.delete', false, function(btn){
      			return { form : btn.data('struct'), id : btn.data('id') }
      		}, false, false, function(btn, data){
      			var message = 'Delete Article?';
      			if (!btn.data('extern')){
      				f.schplitZingConnect($this, 'checkarticle', { articleid : btn.data('id') }, function(d){ 
      					if (d.connected){
      						message = 'Article is used in other SchplitZings. Delete anyway?';
      					}
      					if (confirm(message)){
      						if (opt.debug) { console.log('delete'); }
      						$.post(opt.adminpath, data, function(d) {
								if (opt.debug) { console.log(d); }
								if (d.status){
				      				$('#menu_list_item_'+btn.data('id')).remove();
				      				btn.parents('li.listed_article').remove();
				      				f.schplitZingConnect($this, 'articles', { task : 'delete', articleid : btn.data('id') }, function(){ f.loaded(); });
				      			}
							}, 'json');
      					} else { f.loaded(); if (opt.debug) { console.log('cancel'); } }
      				});
      			} else {
      				if (confirm(message)){
      					if (opt.debug) { console.log('delete'); }
  						$.post(opt.adminpath, data, function(d) {
							if (opt.debug) { console.log(d); }
							if (d.status){
			      				$('#menu_list_item_'+btn.data('id')).remove();
			      				btn.parents('li.listed_article').remove();
			      				f.schplitZingConnect($this, 'connectarticle', { task : 'delete', originarticleid : btn.data('id') }, function(){ f.loaded(); });
			      			}
						}, 'json');
  					}  else { f.loaded(); if (opt.debug) { console.log('cancel'); } }
      			}
      		});
      	},
      	network : function( options ) {
    		if ( options ) { 
        		$.extend( $.fn.admin.defaults, options );
      		}
      		$.fn.admin.defaults.method = 'network';
      		opt = $.fn.admin.defaults;
      		$this = $(this);
      		f.setvars($this);
      		f.logout($this);
      		f.help();
      		if (f.schplitZingCheckConnection($this)){
      			f.initJscrollpane($this, '.field_container', 'field', function(pane, jsp){
	      			
	      		});
	      		f.schplitZingConnect($this, 'network', false, function(data){
	      			if (data.status){
	      				f.loaded();
	      				$.each(data.connections, function(i,e){
		      				var article = $('#listed_article_'+e.id);
		      				article.find('button.connected').addClass('active').text(e.connections.length).data('connect', e.connections);
		      				var networklist = article.find('.article_network');
		      				if (networklist.find('ul').size() < 1){
		      					networklist.append('<ul>');
		      				}
		      				var d = new Date(e.changed);
		      				var n = (d.getTime() > opt.lastlogin.getTime())? true : false;
		      				$.each(e.connections, function(ind, con){
		      					var list = networklist.find('ul');
		      					$('<li>', {
		      						html : '<span class="network_list_title">'+con.schplitzing+' - '+con.schplitzing_author+'</span>'	
		      					}).data('connection', con).data('article', e).appendTo(list);
		      					var dc = new Date(con.changed);
		      					n = (n || dc.getTime() > opt.lastlogin.getTime())? true : false;
		      					if (con.relations){
		      						$.each(con.relations, function(ir, rel){
		      							var dr = new Date(rel.changed);
		      							n = (n || dr.getTime() > opt.lastlogin.getTime())? true : false;
		      						});
		      					}
		      				});
		      				if (n){ article.find('button.connected').addClass('new'); }
		      			});
		      			$('.network_list_title').unbind('click').bind('click', function(){
		      				f.showConnections($this, $(this).parents('.field_container.edit').data('field'), $(this).parent('li').data('connection'), $(this).parent('li').data('article'));
		      				$(this).addClass('title_in_preview');
		      			});
	      			}
	      			
	      		});
	      		$('button.connected').unbind('click').bind('click', function(){
	      			f.hideConnections();
	      			$('.listed_article').removeClass('show');
	      			$(this).parents('.listed_article').addClass('show');
	      		});
      		} else {
      			$('button.button_connect').unbind('click').bind('click', function(){
      				var c = $(this).parent('.info_text');
      				var data = {
      					origin : $(this).data('origin'),
      					author : $(this).data('author'),
      					address : $(this).data('address'),
      					title : f.stripSlashes($(this).data('title')),
      					subtitle : f.stripSlashes($(this).data('subtitle')),
      					description : f.stripSlashes($(this).data('description')),
      				};
      				f.schplitZingActivate($this, data, function(d){
      					$('<div>', {
      						html : d.msg
      					}).css({'margin-top':'10px'}).appendTo(c);
      				}, function(){
      					$('<div>', {
      						html : 'Unable to establish connection with central Database. Send us an email or try again later.'
      					}).css({'margin-top':'10px', 'color':'red'}).appendTo(c);
      				});
      			})
      		}
      		
      	},
      	fragments : function (options, meth){
      		if ( options ) { 
        		$.extend( $.fn.admin.defaults, options );
      		}
      		if (typeof meth == 'undefined'){
      			$.fn.admin.defaults.method = 'fragments';
      		}
      		opt = $.fn.admin.defaults;
      		$this = $(this);
      		f.setvars($this);
      		f.schplitZingCheckConnection($this);
      		f.logout($this);
      		f.help();
      		f.saving();
      		$('.fragmenst_list_title').unbind('click').bind('click', function(){
      			if ($(this).parent().hasClass('collapsed')){
      				$(this).parent().removeClass('collapsed');
      			} else {
      				$(this).parent().addClass('collapsed');
      			}
      		});
      		f.submenu('edit_hidden');
      		$('button.edit').unbind('click').bind('click', function(){
      			var tools = $(this).parents('.form_tools');
      			f.getForm($this, tools.next(), $(this).data('struct'), $(this).data('id'), false, function(load, container, id){
      				f.ckeditor($this, container);
      				f.replaceImg($this);
      				f.selectTag($this);
      				tools.parents('li').addClass('form');
      				f.loaded();
      			});
      		});
      		$('button.cancel').unbind('click').bind('click', function(){
      			if (opt.debug){ console.log('cancel'); }
      			f.loaded();
      			f.ckeditorDestroy($this, $('#'+$(this).data('form')));
      			var form = $('#'+$(this).data('form'));
      			if (form.find('input[name="id"]').val() == '' && form.find('input[name="form"]').val() == 'tags'){
      				form.parents('li.listed_tag').remove()
      			} else {
      				form.remove();
      			}
      			$(this).parents('.listed_fragment, .new_fragment, .listed_tag').removeClass('form');
      		});
      		$('.fragments_tools button.save').unbind('click').bind('click', function(){
      			var form = $('#'+$(this).data('form')); var btn = $(this);
      			if (opt.debug) { console.log('save'); }
      			f.form($this, form, function(data, status, xhr, fm){
      				if (data.lastId){
      					var id = data.lastId;
      				} else {
      					var id = data.id;
      				}
      				f.replaceFragment($this, form, id, function(changed, newlist){
						form.parents('.listed_fragment, .new_fragment').removeClass('form').find('.form_tools_title').text(form.find('input[name="title"]').val());
  						f.ckeditorDestroy($this, form);
  						if (changed){
  							if (form.parents('.listed_fragment').size() > 0 ) {
  								form.parents('.fragmentslist_order').addClass('collapsed');
  								form.parents('.listed_fragment').remove();
  								newlist.parents('.fragmentslist_order').removeClass('collapsed');
  							} else {
  								form.remove();
  							}
  							$this.admin(opt.method)
  						} else {
  							form.remove();
  						}
					});
					f.loaded(btn);
      			});
      		});
      		$('.tags_tools button.save').unbind('click').bind('click', function(){
      			var form = $('#'+$(this).data('form')); var btn = $(this);
      			if (opt.debug) { console.log('save'); }
      			f.form($this, form, function(data, status, xhr, fm){
      				f.loaded(btn);
      				if (data.lastId){
      					var listed = form.parents('.listed_tag').removeClass('form').data('id', data.lastId);
      					listed.find('.form_tools_title').text(form.find('input[name="tag"]').val());
      					listed.find('button').data('id', data.lastId).data('form', 'tags_form_'+data.lastId);
      					form.remove();
      				} else {
      					form.parents('.listed_tag').removeClass('form').find('.form_tools_title').text(form.find('input[name="tag"]').val());
      					form.remove();
      				}
      			});
      		});
      		$('.txtbutton.plus .expandedlink').unbind('click').bind('click', function(){
      			if (opt.debug){ console.log('add of type '+$(this).data('type')); }
      			f.getForm($this, $('.new_fragment'), 'fragments', false, { type : $(this).data('type') }, function(load, container, id){
      				f.ckeditor($this, container);
      				f.replaceImg($this);
      				f.selectTag($this);
      				$('.new_fragment').addClass('form');
      				f.loaded();
      			});
      		});
      		$('.txtbutton.sort .expandedlink').unbind('click').bind('click', function(){
      			if (opt.debug){ console.log('sort by '+$(this).data('sort')); }
      			f.sortFragments($this, $(this).data('sort'), function(){ $this.admin(opt.method); })
      		});
      		$('.edit_tags button.plus').unbind('click').bind('click', function(){
      			if (opt.debug){ console.log('add Tag'); }
      			var c = $('<li>').addClass('listed_tag').data('id', '0').appendTo('ul.tagslist');
      			f.getForm($this, c, 'tags', false, false, function(load, container, id){
      				c.addClass('form');
       				$this.admin(opt.method);
       				f.loaded();
      			});
      		});
      		f.del($this, '.fragments_tools button.delete', false, function(btn){
      			return { form : btn.data('struct'), id : btn.data('id') }
      		}, function(){
      			return confirm('Delete Fragment?');
      		}, function(btn, data){
      			if (data.status){
      				f.loaded();
      				btn.parents('li.listed_fragment').remove();
      			} else {
      				console.log(data.msg);
      				if (confirm(data.msg)){
						var dat = { id : btn.data('id'), form : btn.data('struct'), task : 'forcedelete' }
						$.post(opt.adminpath, dat, function(d) {
							if (opt.debug) { console.log(d); }
							if (d.status){
								f.loaded();
								btn.parents('li.listed_fragment').remove();
							}
						});
					}
      			}
      		});
      		f.del($this, '.tags_tools button.delete', false, function(btn){
      			return { form : btn.data('struct'), id : btn.data('id') }
      		}, function(){
      			return confirm('Delete Tag?');
      		}, function(btn, data){
      			if (data.status){
      				f.loaded();
      				btn.parents('li.listed_tag').remove();
      			}
      		});      		
      	},
      	article : function(options){
      		if ( options ) { 
        		$.extend( $.fn.admin.defaults, options );
      		}
      		$.fn.admin.defaults.method = 'article';
      		opt = $.fn.admin.defaults;
      		$this = $(this);
      		f.setvars($this);
      		$this.admin('fragments', {}, false);
      		f.schplitZingCheckConnection($this);
      		f.logout($this);
      		f.help();
      		f.changeVisibility($this);
      		$('.article_form_input.externpreview').each(function(i,a){
      			f.getExternalArticel($this, $(a).data('url'), $(a).data('externid'), function(data){
      				$(a).find('.article').html(data.content); 
      				$(a).find('.externpreview_origin').html('<a href="'+data.url+'#'+data.id+'" target="_blank">'+data.schplitzing+'</a>');
      				f.loadImages($this);
      			}, function(){
      				$(a).find('.article').html('<span class="unrelated">offline</span>');
      			});
      		});
      		f.dropFragments($this, function(container, data){
      			container.find('.fragmentpreview, .fragments_form').empty();
      			f.getForm($this, container.find('.fragmentpreview'), 'fragment', data.id, false, function(){
      				container.data('id', data.id).removeClass('empty');
      				var index = container.data('key');
      				$('input[name="fragments[]"]').eq(index).val(data.id);
      				$('button.articlesave').removeClass('saved');
      				f.loaded();
      			});
      		});
      		f.dragFragments($this);
      		$('.fragmentdrop').mouseover(function(){
      			if ($(this).data('id')){
      				var id = $(this).data('id');
      				$('.listed_fragment').each(function(i,e){
      					if ($(e).data('id') == id){
      						$(e).addClass('fragmentpointer');
      					}
      				});
      			}
      		}).mouseout(function(){
      			$('.listed_fragment').removeClass('fragmentpointer');
      		});
      		$('button.save').unbind('click').bind('click', function(){
      			var form = $('#'+$(this).data('form'));
				var button = $(this);
      			if (opt.debug) { console.log('save'); }
      			if (form.data('struct') == 'articles'){ var required = ['template']; } else { var required = false; }
      			f.form($this, form, function(data, status, xhr, fm){
      				if (form.data('struct') == 'articles'){
      					if (data.lastId){
      						form.find('input[name="id"]').val(data.lastId);
      					}
      					if (form.find('input[name="extern"]').val() != 1){
      						f.schplitZingConnect($this, form.data('struct'), f.schplitZingGatherData($this, form, 'save'), function(d){ f.loaded(button); if(opt.debug){ console.log(d); } }, function(d){ f.loaded(button); if(opt.debug){ console.log(d); }});
      					}
      				} else if(form.data('struct') == 'fragments') {
      					if (data.lastId){
	      					var id = data.lastId;
	      				} else {
	      					var id = data.id;
	      				}
	      				f.replaceFragment($this, form, id, function(changed, newlist){
							form.parents('.listed_fragment, .new_fragment').removeClass('form').find('.form_tools_title').text(form.find('input[name="title"]').val());
	  						f.ckeditorDestroy($this, form);
	  						if (changed){
	  							if (form.parents('.listed_fragment').size() > 0 ) {
	  								form.parents('.fragmentslist_order').addClass('collapsed');
	  								form.parents('.listed_fragment').remove();
	  								newlist.parents('.fragmentslist_order').removeClass('collapsed');
	  							} else {
	  								form.remove();
	  							}
	  							$this.admin(opt.method)
	  						} else {
	  							form.remove();
	  						}
						});
	      				if (button.data('article')){
	      					var id = (data.lastId) ? data.lastId : data.id;
	      					var container = button.parents('.article_form_input.fragmentdrop');
	      					container.find('.fragmentpreview').empty();
	      					f.getForm($this, container.find('.fragmentpreview'), 'fragment', id, false, function(){
			      				container.data('id', id).removeClass('empty form');
			      				container.find('button').data('id', id);
			      				var index = container.data('key');
			      				$('input[name="fragments[]"]').eq(index).val(id);
			      				$('button.articlesave').removeClass('saved');
			      				f.loaded(button);
			      			});
	      				} else {
	      					f.loaded(button);
	      				}
      				}
      			}, required);
      		});
      		$('button.edit').unbind('click').bind('click', function(){
      			if ($(this).data('article')){
      				var c = $(this).parents('.fragmentdrop');
      				f.getForm($this, c.find('.fragments_form'), $(this).data('struct'), $(this).data('id'), false, function(load, container, id){
	      				f.ckeditor($this, container);
	      				f.replaceImg($this);
	      				c.find('.dropbox_tools button').data('form', container.find('form').attr('id'))
	      				c.addClass('form');
	      				f.loaded();
	      			});
      			} else {
      				var tools = $(this).parents('.form_tools');
	      			f.getForm($this, tools.next(), $(this).data('struct'), $(this).data('id'), false, function(load, container, id){
	      				f.ckeditor($this, container);
	      				f.replaceImg($this);
	      				tools.parents('li').addClass('form');
	      				f.loaded();
	      			});
      			}
      		});
      		$('button.cancel').unbind('click').bind('click', function(){
      			if (opt.debug){ console.log('cancel'); }
      			f.loaded();
  				f.ckeditorDestroy($this, $('#'+$(this).data('form')));
      			$('#'+$(this).data('form')).remove();
      			var c = $(this).parents('.listed_fragment, .fragmentdrop, .new_fragment, .listed_tag');
      			c.removeClass('form');
      			if ($(this).data('article')){
      				c.find('.fragmentpreview, .fragments_form').empty();
	      			f.getForm($this, c.find('.fragmentpreview'), 'fragment', c.data('id'), false, function(){
	      				f.loaded();
	      			});
      			}
      		});
      		$('button.articlecancel').unbind('click').bind('click', function(){
      			if (opt.debug){ console.log('cancel'); }
      			location.reload();
      		});
      		$('button.remove').unbind('click').bind('click', function(){
      			if (opt.debug){ console.log('remove'); }
      			f.loaded();
      			var c = $(this).parents('.fragmentdrop');
      			$('input[name="fragments[]"]').eq(c.data('key')).val('');
      			$('button.articlesave').removeClass('saved');
      			c.addClass('empty').find('.fragmentpreview').empty();
      		});
      		$('.template_button').unbind('click').bind('click', function(){
      			var button = $(this);
      			f.changeTemplate($this, $(this).parents('.articles_form'), $(this).data('template'), function(d){
      				$('.template_button').removeClass('active');
      				button.addClass('active');
      				$this.admin(opt.method);
      				f.loaded();
      			});
      		});
      		$('button.new').unbind('click').bind('click', function(){
      			var c = $(this).parents('.fragmentdrop');
      			f.getForm($this, c.find('.fragments_form'), $(this).data('struct'), false, { type : c.data('type') }, function(load, container, id){
      				f.ckeditor($this, container);
      				f.replaceImg($this);
      				c.find('.dropbox_tools button').data('form', container.find('form').attr('id'))
	      			c.removeClass('empty').addClass('form');
	      			f.loaded();
      			});
      		});
      	}
  	};
  	
  	var f = {
  		setvars : function(elem){
  			opt = elem.admin.defaults;
  			elem.admin.defaults.lastconnection = new Date(opt.lastconnection);
			elem.admin.defaults.logintime = new Date(opt.logintime);
			elem.admin.defaults.lastlogin = new Date(opt.lastlogin);
  		},
		form : function(elem, form, callback, validate, required){
			opt = elem.admin.defaults;
			if (typeof form != 'object'){ form = $(form); }
			form.ajaxSubmit({
				beforeSubmit:	function(formData, jqForm, options){
									f.loading();
									var result = true;
									if (typeof required == 'object'){
										$.each(required, function(i,e){
											if (!jqForm[0][e].value) { 
		       									jqForm.find('label[for="'+e+'"]').addClass('alert');
		       									result = false;
		       								}
										});
									}
									if (typeof validate == 'function') { var valid = validate(formData, jqForm, options); if (!valid){ result = false; } }
									return result;
								}, 
				success:   		function(data, status, xhr, form){
									if (opt.debug) { console.log(data); }
									f.loaded();
									if (data.status){
										if(typeof callback == 'function') { callback(data, status, xhr, form); }
									} else {
										if (data.msg == 'not logged in'){
											f.notloggedin(function(){
												form.ajaxSubmit();
											});
										}
									}
									return false;
								},
				dataType:		'json'
			});
		},
		message : function(callback){
			var msg = $('<div>', {
				id : 'message',
				html : '<div id="message_content"><div id="message_text"><div id="message_close"><button class="txtbutton close" title="close">close</button></div></div></div>'
			});
			if (typeof callback == 'function'){ callback(msg.find('#message_text')); }
			if ($('#message').size() > 0){ 
				$('#message').fadeOut( '400', function(){ 
					$(this).remove();
					msg.appendTo('body').fadeIn().find('#message_close').bind('click', function(){
						msg.fadeOut( '400', function(){ $(this).remove(); });
					});
				}); 
			} else {
				msg.appendTo('body').fadeIn().find('#message_close').bind('click', function(){
					msg.fadeOut( '400', function(){ $(this).remove(); });
				});
			}
		},
		notloggedin : function(callback){
			f.message(function(e){
				$('<div id="login"><div class="about_login"><div class="login_header"><span class="login_header_title">Please loggin again</span></div><form id="login_form" class="loginform" action="admin/index.php" method="post" enctype="multipart/form-data"><input type="hidden" name="form" value="login"><input type="hidden" name="task" value="login"><div class="login_form_cell"><label class="formlabel " for="uid">Username</label><br><input type="text" name="uid" class="formfield" value=""></div><div class="login_form_cell"><label class="formlabel" for="pwd">Password</label><br><input type="password" name="pwd" class="formfield" value=""></div><div class="login_form_cell"><br><input class="button rounded" type="submit" value="login"></div></form></div></div>').appendTo(e);
				e.find('.loginform').ajaxForm({
					beforeSubmit:	function(){ f.loading(); return true; },
					success:   		function(data, status, xhr, form){
										f.loaded();
										if (data.status){
											$('#message').fadeOut( '400', function(){ 
												$(this).remove();
												if (typeof callback == 'function'){ callback(); }
											});
										} else {
											if (data.msg == 'wrong username'){
												$("label[for='uid']").addClass('alert');
											} else if (data.msg == 'wrong password'){
												$("label[for='pwd']").addClass('alert');
											}
										}
									},
					dataType:		'json'
				});
				return false;
			});
		},
		submenu : function(hide, callback){
			$('.submenu_button').unbind('click').bind('click', function(){
				$('.submenu_button').removeClass('show');
				$(this).addClass('show');
				$('.navigate').addClass(hide);
				$('.'+$(this).data('editor')).removeClass(hide);
				window.location.hash = $(this).data('editor');
				if (typeof callback == 'function'){ callback(); }
			});
			if (window.location.hash){
				var navigate = window.location.hash;
				$('.submenu_button').each(function(){
					if ('#'+$(this).data('editor') == navigate){
						$('.submenu_button').removeClass('show');
						$(this).addClass('show');
						$('.navigate').addClass(hide);
						$('.'+$(this).data('editor')).removeClass(hide);
					}
				})
			} 
		},
		help : function(){
			$('.help').unbind('click').bind('click', function(){
    			var video = $(this).data('vimeoid');
    			f.message( function(e){
    				e.append('<iframe src="http://player.vimeo.com/video/'+video+'" width="790px" height="488px" frameborder="0"></iframe>');
    			});
    		});
		},
		logout : function(elem){
			opt = elem.admin.defaults;
			$('a.logout').unbind('click').bind('click', function(event){
				event.preventDefault();
				dat = {
					task : 'logout',
				}
				$.post(opt.adminpath, dat, function(data) {
					console.log(data);
					window.location.reload();
				});
			});
		},
		cancel : function(elem, callback){
			opt = elem.admin.defaults;
			$('button.cancel').unbind('click').bind('click', function(){
				if (opt.debug) { console.log('cancel'); }
				form = $('#'+$(this).data('form'));
				form.resetForm();
				if (typeof callback == 'function'){ callback(form); }
			});
		},
		save : function(elem, button, form, callback, validate){
			opt = elem.admin.defaults;
			if (typeof button != 'object'){ button = $(button); }
			button.unbind('click').bind('click', function(){
				if (opt.debug) { console.log('save'); }
				if (form){
					if (typeof form != 'object'){ form = $(form); }
				} else {
					form = $('#'+$(this).data('form'));
				}
				f.form(elem, form, callback, validate);
			});
		},
		del : function(elem, button, form, data, confirm, callback, differentcall){
			opt = elem.admin.defaults;
			if (typeof button != 'object'){ button = $(button); }
			button.unbind('click').bind('click', function(){
				var btn = $(this);
				if (opt.debug) { console.log('delete'); }
				if (form){
					form = $('#'+$(this).data('form'));
					if (form.find('input[name="id"]').val() != 0){
						var dat = { id : form.find('input[name="id"]').val(), form : form.find('input[name="form"]').val() }
					}
				} else {
					form = $(this);
				}
				if (typeof data == 'function'){
					dat = data($(this));
				}
				if (typeof dat == 'object'){
					dat['task'] = 'delete';
					if (typeof differentcall == 'function'){ 
						differentcall(btn, dat); 
					} else {
						if (typeof confirm == 'function'){ var conf = confirm(form); } else { conf = true; }
						if (conf){
							$.post(opt.adminpath, dat, function(d) {
								if (opt.debug) { console.log(d); }
								if (typeof callback == 'function'){ callback(form, d); }
							}, 'json');
						}
					}
				}
			});
		},
		add : function(elem, button, condition, target, form, callback){
			opt = elem.admin.defaults;
			if (target){ if (typeof target != 'object'){ target = $(target); } } else { target = button.data('target'); }
			if (button){ if (typeof button != 'object'){ button = $(button); } } else { button = $('button.add'); }
			button.unbind('click').bind('click', function(){
				if (opt.debug) { console.log('add'); }
				if (condition){			
					$.get(opt.formpath, form, function(data){
						target.append($(data));
						if (typeof callback == 'function'){ callback(); }
					});
				}
			});
		},
		replaceImg : function(elem){
			$('button.replaceimg').unbind('click').bind('click', function(){
				var c = $(this).parents('.formblock.imgblock');
				c.append('<input type="file" name="file" class="formfile" value=""><input type="hidden" name="replace" value="'+$(this).data('replace')+'" />');
				c.find('.image').hide();
				return false;
			});
		},
		bindChanges : function(elem, form, target){
			opt = elem.admin.defaults;
			form.each(function(ind,fm){
				if (typeof target == 'object'){
					$.each(target, function(val,tar){
						if (typeof tar == 'object'){
							$(fm).find('input[name="'+val+'"]').bind('change', function(){
								if (opt.debug) { console.log('changed '+val); }
								tar.text($(this).val());
							});
						} else {
							$(fm).find('input[name="'+val+'"]').bind('change', function(){
								if (opt.debug) { console.log('changed '+val); }
								$(fm).prev().find(tar).text($(this).val());
							});
						}
					})
				}
			})
		},
		changeVisibility : function(elem){
			opt = elem.admin.defaults;
			$('.changevisibility').change(function(){
				var vis = 0;
				if ($('input[name="visibility_article"]').is(':checked') && $('input[name="visibility_menu"]').is(':checked')){
					vis = 1;
				} else if ($('input[name="visibility_article"]').is(':checked') && !$('input[name="visibility_menu"]').is(':checked')){
					vis = 2;
				} else if (!$('input[name="visibility_article"]').is(':checked') && $('input[name="visibility_menu"]').is(':checked')){
					vis = 3;
				}
				$('input[name="visibility"]').val(vis);
				if (opt.debug){ console.log('visibility '+$('input[name="visibility"]').val()); }
			});
		},
		initJscrollpane : function(elem, pane, id, callback){
			opt = elem.admin.defaults;
			if (opt.jscrollpanes){
				f.reinitJscrollpane(elem);
			} else {
				elem.admin.defaults.jscrollpanes = {};
				if (typeof pane != 'object'){ pane = $(pane); }
				pane.each(function(){
					var scroll = $(this).jScrollPane(opt.jscrolloptions);
					elem.admin.defaults.jscrollpanes[$(this).data(id)] = scroll.data('jsp');
					if(typeof callback == 'function'){ callback(pane, elem.admin.defaults.jscrollpanes[$(this).data(id)]); }
				});
			}
		},
		reinitJscrollpane : function(elem){
			opt = elem.admin.defaults;
			$.each(opt.jscrollpanes, function(ind, e){
				e.reinitialise();
			});
		},
		sortableArticles : function(elem, lists, articles, sorthandle, createhelper, callback) {
			opt = elem.admin.defaults;
  			$(lists).sortable({
				connectWith: lists,
				cursor: 'pointer',
				appendTo: 'body',
				handle: sorthandle,
				helper : function(event, ui){
							$(lists).css({'z-index':'10'});
							$(this).css({'z-index':'5'});
							if (typeof createhelper == 'function'){ return createhelper(event, ui); } else { return ui.clone(); }
				},
				items: "li:not(.white)",
				receive: function(event, ui) {
							f.loading();
							f.schplitZingConnect(elem, 'articles', { task:'save', articleid:ui.item.data('id'), field:ui.item.parents(lists).data('field')});
							if (ui.item.data('extern')){
								f.schplitZingConnect(elem, 'connectarticle', { task:'update', originarticleid:ui.item.data('id'), field:ui.item.parents(lists).data('field')}, function(){ f.loaded(); });
							}
				},
				update: function(event, ui) {
						f.loading();
						var field = ui.item.parents(lists);
						var position = field.find('.listed_article').index(ui.item);
						f.moveMenuListItem(elem, ui.item.data('id'), field.data('field'), position);
						f.sortArticles(elem, lists, articles, function(d){
							f.reinitJscrollpane(elem);
							f.loaded();
							if (typeof callback == 'function'){ callback(event, ui); }
						});
				}
			});
  		},
  		sortArticles : function(elem, articlelists, articles, callback){
  			opt = elem.admin.defaults;
			if (typeof articlelists != 'object'){ articlelists = $(articlelists); }
			articlelists.each(function(){
				var i = 1; var sort = {};
				$(this).find(articles).each(function(){
					if ($(this).data('id') != "w" && $(this).data('id') != "e"){
						$(this).data('sort', i); sort[i] = $(this).data('id'); i++;
					}
				});
				var data = { form: 'articles', task: 'position', field: $(this).data('field'), sort: sort }
				if (opt.debug){ console.log(data); }
				$.post(opt.adminpath, data, function(data) {
					if (opt.debug){ console.log(data); }
					if (typeof callback == 'function'){ callback(data) }
				}, 'json');
			});
		},
		moveMenuListItem : function(elem, id, field, position){
			opt = elem.admin.defaults;
			var item = false; var menu = false; var mp = false;
			$('.menu_list_item').each(function(){
				if ($(this).data('id') == id){ item = $(this); mp = $(this).find('.menu_list_point'); }
			});
			$('.menu_list').each(function(){
				if ($(this).data('field') == field){ menu = $(this); }
			});
			if(field%2 == 0){ item.find('.menu_list_title').before(mp); } else { item.find('.menu_list_title').after(mp); }
			var next = menu.find('.menu_list_item').eq(position);
			next.after(item);
		},
		loadImages : function(elem, images, origin){
			opt = elem.admin.defaults;
			images = (typeof images == 'object')? images.find('.imgtoload') : $('.imgtoload');
			images.each(function(index){
				var article = $(this).parents('.article');
				var path = (origin)? origin+$(this).data('src') : ((article.data('url'))? article.data('url')+$(this).data('src') : $(this).data('src'));
				var toload = $(this);
				if ($(this).data('width')){
					var img = $('<img class="image" src="'+path+'" style="width:'+$(this).data('width')+'%" />');
					img.load(function(){
						toload.replaceWith($(this));
						f.reinitJscrollpane(elem);
					});
				} else {
					var img = $('<img class="image" src="'+path+'" />');
					img.load(function(){
						toload.replaceWith($(this));
						f.reinitJscrollpane(elem);
					});
				}
			});
		},
		loadExternalArticles : function(elem){
			var artsize = $('.article.extern').size()-1;
			$('.article.extern').each(function(i,e){
				var art = $(this);
				if ($(this).data('extern')){
					f.getExternalArticel(elem, art.data('url'), art.data('externid'), function(data){
						art.html(data.content);
						if (artsize == i){
							f.reinitJscrollpane(elem);
							f.loadImages(elem, $('.article.extern'));
						}
					}, function(){
						art.html('<span class="unrelated">offline</span>');
					});
				}
			});
		},
		getCurrentArticle : function (field, position){
			current = false;
			field.find('.listed_article').each(function(){
				var curPos = position + 50;
				var artTop = $(this).position().top;
				var artHeight = $(this).height();
				if ( artTop <= curPos && (artTop + artHeight) > curPos){
					current = $(this);
				}
			});
			return current;
		},
		scrollToRelations : function(elem, field){
			opt = elem.admin.defaults;
			if (typeof field == 'object'){ field = field.data('field'); }
			var relations = $('#'+opt.current[field]).data('relations');
			$.each(relations, function(fd, elem){
				if (elem == 'w' || elem == 'e') {
					elem = elem+fd;
				}
				if (field != fd){
					if ($('#field_container_'+fd).find('#'+elem).size() < 1){
						elem = 'e'+fd;
					}
					if (Math.abs($('#'+elem).position().top - opt.jscrollpanes[fd].getContentPositionY()) > 20){
						opt.jscrollpanes[fd].scrollToElement($('#'+elem), true, true);
					}
				} else if (field == fd && Math.abs($('#'+opt.current[fd]).position().top - opt.jscrollpanes[fd].getContentPositionY()) > 20){
					opt.jscrollpanes[fd].scrollToElement($('#'+opt.current[fd]), true, true);
				}
			});
		},
		saveRelations : function(elem, field, callback){
			opt = elem.admin.defaults;
			if (opt.debug){ console.log(opt.current); }
			if (typeof field == 'object'){ field = field.data('field'); }
			var datintern = { task : 'relations', form : 'relations', id : false, relations : {} }
			var datextern = { systemarticleid : false, systemid : false, articleid : false, relationid : {}, relationsystem : {}, relationfield : {} };
			if (!isNaN(opt.current[field])){
				var j = 0;
				$.each(opt.current, function(i,e){
					var article = $('#listed_article_'+e);
					if (i == field){
						datintern['id'] = e;
						datextern['systemarticleid'] = e;
						if (article.data('extern')){
							datextern['systemid'] = article.data('system');
							datextern['articleid'] = article.data('articleid');
						} else {
							datextern['systemid'] = opt.schplitzingid;
							datextern['articleid'] = e;
						}
					} else {
						datintern['relations'][i] = e;
						if (article.data('extern')){
							datextern['relationid'][j] = article.data('articleid');
							datextern['relationsystem'][j] = article.data('system');
						} else {
							datextern['relationid'][j] = e;
							datextern['relationsystem'][j] = 0;
						}
						datextern['relationfield'][j] = i;
						j++;
					}
				});
				if (opt.debug){ console.log(datextern); }
				if (datintern['id']){
					$.post(opt.adminpath, datintern, function(data) {
						if (opt.debug){ console.log(data); }
						if (data.status){
							$('#'+datintern['id']).data('relations', opt.current);
							f.scrollToRelations(elem, field);
							f.schplitZingConnect(elem, 'relations', datextern, function(){ f.loaded(); }, function(){ f.loaded(); });
						}
						if (typeof callback == 'function'){ callback(data, datintern, datextern); }
					}, 'json');
				}
				
			}
		},
		getForm : function(elem, container, structure, id, dat, callback){
			opt = elem.admin.defaults;
			f.loading();
			if (opt.debug){ console.log('get Form'); }
			if (typeof container != 'object') { container = $(container); }
			if (typeof id == 'undefined'){ var data = { struct : structure } } else { var data = { struct : structure, id : id } }
			if (typeof dat == 'object'){ $.each(dat, function(i,e){ data[i] = e }); }
			if (container.children('form').size() < 1 || structure == 'template'){
				$.get(opt.formpath, data, function(d){
					container.append(d);
					if (typeof callback == 'function'){ callback(true, container, id); }
				})
			} else {
				if (typeof callback == 'function'){ callback(false, container, id); }
			}
		},
		ckeditor : function(elem, form){
			form.find('.formtext, .formheadline').each(function(){
				var options = { toolbar : 'Basic' }
				if ($(this).hasClass('formheadline')) { options['customConfig'] = 'config_headline.js'; } else { options['customConfig'] = 'config_text.js'; }
				var editorID = $(this).attr("id");
				var instance = CKEDITOR.instances[editorID];
				if (instance) { 
            		instance.destroy();
            		CKEDITOR.remove(instance);
            	}
            	CKEDITOR.replace(editorID, options);
			});
		},
		ckeditorDestroy : function(elem, form){
			form.find('.formtext, .formheadline').each(function(){
				var editorID = $(this).attr("id");
				var instance = CKEDITOR.instances[editorID];
				if (instance) { 
            		instance.destroy();
            		CKEDITOR.remove(instance);
            	}
			});
		},
		dragFragments : function(elem) {
  			$(".listed_fragment").draggable({
  				helper: function(){
  							var helper = $(this).find('.form_tools_title, .template_icon').clone()
  							return $('<div>', {
  								html : helper
  							}).addClass('listed_fragment drag_fragment').data('type', $(this).data('type'));
  				},
				revert:	'invalid',
				iframeFix: true,
				appendTo: '#edit',
				zIndex: 12
			});
  		},
  		dropFragments : function(elem, callback) {
  			opt = elem.admin.defaults;
  			$( ".fragmentdrop" ).droppable({
				hoverClass: "droppable_active",
				accept: function(d) {
							if (opt.templatemode){
								if (d.hasClass('listed_fragment') && d.data('type') == $(this).data('type')){
									return true;
								} else {
									return false;
								}
							} else {
								if (d.hasClass('listed_fragment')){
									return true;
								} else {
									return false;
								}
							}
						},
				drop: 	function( event, ui ) {
							if (opt.debug){ console.log('dropped'); }
							var data = ui.draggable.data();
							ui.helper.remove();
							if (typeof callback == 'function'){ callback($(this), data); }
					  	}
			});
  		},
  		changeTemplate : function(elem, form, template, callback){
  			opt = elem.admin.defaults;
  			var c = form.parents('.edit_half');
  			var o = { text : [], img : [], video : [], headline : [] };
  			c.find('.article_form_input.fragmentdrop').each(function(i,e){
  				if ($(e).data('id')){
  					o[$(e).data('type')].push($(e).data('id'));
  				}
  				$(this).remove();
  			});
  			var data = { temp : template };
  			var i = { text : 0, headline : 0, img : 0, video : 0 }
  			$.each(opt.templatevars[template], function(j,e){
  				if (o[e][i[e]]){ data['key'+j] = o[e][i[e]]; i[e]++; }
  			});
  			if (opt.debug){ console.log(data); }
  			f.getForm(elem, c, 'template', false, data, function(d, container){
  				form.find('input[name="fragments[]"]').remove();
  				c.find('.article_form_input.fragmentdrop').each(function(i,e){
  					$('<input type="hidden" name="fragments[]" >').appendTo(form).val($(this).data('id'));
  				});
  				form.find('input[name="template"]').val(template);
  				if (typeof callback == 'function'){ callback(d) }
  			});
  		},
  		replaceFragment : function(elem, form, id, callback){
  			opt = elem.admin.defaults;
  			var o = $('.edit_half.edit_fragments').data('sort');
  			var c = false;
  			var p = (form.parents('.fragmentslist_order').size() > 0)? form.parents('.fragmentslist_order').data('order') : false;
  			if (o == 'type'){
  				var s = form.find('input[name="type"]').val();
  			} else if (o == 'tag'){
  				var s = form.find('select[name="tags"]').val();
  				form.find('select[name="tags"] option').each(function(){
  					if ($(this).val() == s){ s = (s)? $(this).text(): ''; }
  				})
  			} else if (o == 'date'){
  				var s = f.dateToUtc();
  			}
  			if (p != s){
 				if(opt.debug){ console.log('position changed'); }
  				$('.fragmentslist_order').each(function(i,e){
	  				if ($(this).data('order') == s){ c = $(this).find('ul.fragmentslist'); }
	  			});
	  			if (!c){
	  				var sort = (o == 'date')? f.formatUtcDate(s) : s;
	  				c = f.createListOrderElem(s, sort, 'top');
	  			}
				f.getForm(elem, c, 'listedfragment', id, false, function(d, container){
	  				if (typeof callback == 'function'){ callback(true, c, d) }
	  			});
  			} else {
  				if(opt.debug){ console.log('position not changed'); }
  				if (typeof callback == 'function'){ callback(false, c, false) }
  			}
  		},
  		sortFragments : function(elem, sortby, callback){
  			var fragments = {};
  			var keys = new Array();
  			$('li.listed_fragment').each(function(i,e){
  				var sort = (sortby == 'date')? f.dateToUtc($(this).data('date')) : $(this).data(sortby);
  				if (typeof fragments[sort] == 'undefined') { fragments[sort] = new Array(); }
  				fragments[sort].push($(this).clone());
  				if ($.inArray(sort, keys) == -1){ keys.push(sort); }
  			});
  			keys.sort();
  			if (sortby == 'date'){ keys.reverse(); }
  			$('div.fragmentslist_order').remove();
  			$.each(keys, function(i,e){
  				var element = fragments[e];
  				var sort = (sortby == 'date')? f.formatUtcDate(e) : e;
  				var list = f.createListOrderElem(e, sort);
  				$.each(element, function(ind, fr){
  					fr.appendTo(list);
  				});
  			});
  			$('.edit_half.edit_fragments').data('sort', sortby);
  			if (typeof callback == 'function'){ callback(); }
  		},
  		createListOrderElem : function(index, sort, position){
  			if (typeof position == 'undefined'){
  				var cat = $('<div>').addClass('fragmentslist_order collapsed').data('order',index).appendTo('.edit_half.edit_fragments').append($('<div>', { html : '['+sort+']'}).addClass('fragmenst_list_title'));
  			} else if (position == 'top') {
  				var cat = $('<div>').addClass('fragmentslist_order collapsed').data('order',index).insertAfter('.edit_half.edit_fragments .new_fragment').append($('<div>', { html : '['+sort+']'}).addClass('fragmenst_list_title'));
  			}
			var list = $('<ul>').addClass('fragmentslist').appendTo(cat);
			return list;
  		},
  		dateToUtc : function(date){
  			if (typeof date == 'undefined'){
  				var d = new Date();
  			} else {
  				var d = new Date(date);
  			}
  			d.setHours(0); d.setMinutes(0); d.setSeconds(0);
  			return Date.parse(d.toGMTString());
  		},
  		formatUtcDate : function(date){
  			var d = new Date(parseFloat(date));
  			var fd = d.getDate()+'.'+(d.getMonth()+1)+'.'+d.getFullYear();
  			return fd;
  		},
  		selectTag : function(elem){
  			opt = elem.admin.defaults;
			$('.formselect.tags').unbind('change').bind('change', function(){
				var sel = $(this);
				if (sel.val() == 'add'){
					var newtag = prompt("Add new Tag", "");
					if (newtag){
						dat = {
							task : 'save',
							form : 'tags',
							id : '0',
							tag : newtag
						}
						$.post(opt.adminpath, dat, function(data) {
							if (opt.debug){ console.log(data); }
							if (data.status && data.lastId){	
								$('<option value="'+data.lastId+'" selected>'+newtag+'</option>').insertBefore('.addtag');
								if ($('.edit_half.edit_fragments').data('sort') == 'tag'){
									$('<div>', {
										html : '<div class="fragmenst_list_title">['+newtag+']</div><ul class="fragmentslist" ></ul>'
									}).addClass('fragmentslist_order').data('order', newtag).appendTo('.edit_half.edit_fragments');
								}
								var c = $('<li>').addClass('listed_tag').data('id', data.lastId).appendTo('ul.tagslist');
				      			f.getForm($this, c, 'tags', false, false, function(load, container, id){
				      				c.find('.form_tools_title').text(newtag);
      								c.find('button').data('id', data.lastId).data('form', 'tags_form_'+data.lastId);
				      				container.find('form').remove();
				      				f.loaded();
				       				$this.admin(opt.method);
				      			});
							}
						}, 'json');
					}
				}
			});
		},
  		getExternalArticel : function(elem, origin, id, callback){
  			$.ajax({
			  	dataType: 'jsonp',
			  	jsonp: 'jsonp_callback',
			  	url: origin+'json/json.php?id='+id,
			  	success: function (data) {
					if (typeof callback == 'function'){ callback(data); }
				},
				error: function(jqXHR, textStatus, errorThrown){
					if (typeof error == 'function'){ error(jqXHR, textStatus, errorThrown); }
				}
			});
  		},
  		schplitZingConnect : function(elem, structure, data, callback, error, check){
  			opt = elem.admin.defaults;
  			if (opt.schplitzingconnected || check){
	  			f.loading();
	  			$.ajax({
				  	type : 		'POST',
				  	crossDomain: true,
				  	url : 		opt.schplitzingconnect+'?id='+opt.schplitzingid+'&pass='+opt.schplitzingpass+'&struct='+structure,
				  	data : 		data,
				  	success : 	function(data, textStatus, jqXHR){
									if(opt.debug){ console.log('schplitZingConnect', data); }
									if (typeof callback == 'function'){ callback(data); }
					},
					error :		function(jqXHR, textStatus, errorThrown){
									if(opt.debug){ console.log('schplitZingConnect', textStatus) };
									f.loaded();
									if (typeof error == 'function'){ error(data); }
					},
					dataType :	'json'
				});
			} else {
				if(opt.debug){ console.log('schplitZingConnect', 'not connected') };
				f.loaded();
				if (typeof error == 'function'){ error(data); }
			}
  		},
  		schplitZingCheckConnection : function(elem){
  			opt = elem.admin.defaults;
  			var result = false;
  			console.log('check connection', opt.schplitzingconnected);
  			if (!opt.schplitzingconnected){
  				f.schplitZingConnect(elem, 'connection', false, function(d){
  					if (d.status){
						da = { form : 'connection', task : 'connect' }
						$.post(opt.adminpath, da, function(dat) {
							f.loaded();
							if (dat.status){	
								elem.admin.defaults.schplitzingconnected = true;
								result = true;
							}
							return result;
						}, 'json');
					}
  				}, function(){ return result; }, true);
  			} else {
  				return true;
  			}
  		},
  		schplitZingActivate : function(elem, data, callback, error){
  			opt = elem.admin.defaults;
  			var url = opt.schplitzingconnect.replace(/index.php/, "activate.php");
  			f.loading();
  			$.ajax({
			  	type : 		'POST',
			  	crossDomain: true,
			  	url : 		url+'?task=create',
			  	data : 		data,
			  	success : 	function(dat, textStatus, jqXHR){
								if(opt.debug){ console.log('schplitZingActivate', dat); }
								da = { form : 'infos', task : 'save', identifier : dat.id, identifierpass : dat.task }
								$.post(opt.adminpath, da, function(dat) {
									f.loaded();
									if (typeof callback == 'function'){ callback(dat); }
								}, 'json');
				},
				error :		function(jqXHR, textStatus, errorThrown){
								if(opt.debug){ console.log('schplitZingActivate', textStatus) };
								f.loaded();
								if (typeof error == 'function'){ error(data); }
				},
				dataType :	'json'
			});
  		},
  		schplitZingUpdateConnections : function(elem, ignoredate){
  			opt = elem.admin.defaults;
  			if (opt.schplitzingconnected){
				if (opt.logintime.getTime() > opt.lastconnection.getTime() || opt.debug){
		  			f.loading();
		  			d = { form : 'connection', task : 'update' }
					$.post(opt.adminpath, d, function(data) {
						if (opt.debug){ console.log('get update information', data); }
						if (data.status){
							if (ignoredate){ data.ignoredate = true; }
							f.schplitZingConnect(elem, 'update', data, function(d){
								if (data.status){
									d = { form : 'connection', task : 'lastconnection' }
									$.post(opt.adminpath, d, function(dat) {
										if (opt.debug){ console.log('last connection', dat); }
										f.loaded();
										if (dat.status){
											elem.admin.defaults.lastconnection = new Date(dat.msg);
										}
									}, 'json');
								}
							}, function(d){
								f.loaded();
							})
						}
					}, 'json');
				}  			
  			}
  		},
  		schplitZingGatherData : function(elem, form, task){
  			var data = f.formSerialize(form);
  			var structure = form.data('struct');
  			var fields = {
  				articles : ['id','title','lead','text','field','template','author' ],
  				infos : [ 'title','subtitle','screenshot','author','description','address' ]
  			}
  			var changes = { articles : { id:'articleid' }, infos:{} }
  			$.each(data, function(i,e){
  				if($.inArray(i, fields[structure]) == -1){
  					delete data[i];
  				} else if (typeof changes[structure][i] != 'undefined'){
  					data[changes[structure][i]] = e; delete data[i];
  				}
  			});
  			if (structure == 'articles'){
  				data['text'] = '';
  				$('.article_form_input div.headline, .article_form_input div.normal, .article_form_input textarea').each(function(){
					data['text'] += $(this).text();
				});
  			}
  			if (typeof task != 'undefined'){ data['task'] = task; }
  			if (opt.debug){ console.log(data); }
  			return data;
   		},
   		showConnections : function(elem, field, data, article){
   			opt = elem.admin.defaults;
   			$('.overlay').remove();
   			if (field < 3){
   				var left = 3; var right = 4;
   				if (field == 1){ var hide = 2; } else { var hide = 1; }
   			} else {
   				var left = 1; var right = 2;
   				if (field == 3){ var hide = 4; } else { var hide = 3; }
   			}
   			if (opt.debug) { console.log(data); }
   			if (opt.debug) { console.log(article); }
			var sz = $('<div>', {
				id : 'overlay_'+left
			}).addClass('overlay').appendTo(elem).css('display', 'none').html(data.schplitzing+'<br>'+data.schplitzing_subtitle+'<br>'+data.schplitzing_author+'<br>'+data.schplitzing_description);
			var rel = $('<div>', {
				id : 'overlay_'+right
			}).addClass('overlay').appendTo(elem).css('display', 'none');
			$('<div>', {
				id : 'overlay_'+hide
			}).addClass('overlay overlay_hide').appendTo(elem).css('display', 'none');
			var filled = new Array();
			filled.push(data.field);
			f.getExternalArticel(elem, article.schplitzing_url, article.origin_id, function(d){
				if (opt.debug){ console.log(d); }
				var prev = $('<div>', {
					id : 'relations_preview_'+data.field 
				}).addClass('relations_preview master_preview').html(d.content).appendTo(rel);
				f.loadImages(elem, prev, article.schplitzing_url);
			});
			
			if (data.relations){
				$.each(data.relations, function(i,e){
					filled.push(e.field);
					if (e.id != 'w' && e.id != 'e'){
						if (e.schplitzing_url){ var url = e.schplitzing_url; } else { var url = data.schplitzing_url; }
						f.getExternalArticel(elem, url, e.id, function(d){
							if (opt.debug){ console.log(d); }
							var prev = $('<div>', {
								id : 'relations_preview_'+e.field 
							}).addClass('relations_preview').html(d.content).appendTo(rel);
							f.loadImages(elem, prev, url);
						});
					} else {
						$('<div>', {
							id : 'relations_preview_'+e.field 
						}).addClass('relations_preview').appendTo(rel);
					}
				});
			}
			$.each(['1','2','3','4'], function(index,fi){
				if ($.inArray( fi, filled ) == -1){
					$('<div>', {
						id : 'relations_preview_'+fi 
					}).addClass('relations_preview').appendTo(rel);
				}	
			});
			$('.overlay').fadeIn(); $('.edit_header.network').fadeOut(); 		
		},
		hideConnections : function(){
			$('.overlay').fadeOut('400', function(){
				$(this).remove();
				$('.network_list_title').removeClass('title_in_preview');
			});
			$('.edit_header.network').fadeIn();
		},
		saving : function(){
			$('button.save').each(function(){
				var btn = $(this);
				$('#'+btn.data('form')).find('input, textarea').change(function(){
					btn.removeClass('saved');
				})
			});
		},
		loading : function(){
			$('#header_loading').addClass('loading');
		},
		loaded : function(highlight){
			$('#header_loading').removeClass('loading');
			if (typeof highlight == 'object'){
				highlight.addClass('saved');
			} else if (typeof highlight != 'undefined'){
				$('body').animate({ backgroundColor: "#DEE" }, 100).animate({ backgroundColor: "#EEE" }, 100);
			}
			
		},
  		formSerialize : function(form){
  			var result = {};
  			form.find('input, textarea').each(function(i,e){
  				var attr = $(this).attr('name');
  				if (attr.indexOf('[') != -1){
  					var ind = attr.replace(/\[(\S*)\]/, '');
  					var sub = attr.match(/\[(\S*)\]/, '');
  					result[ind] = (result[ind]) ? result[ind] : ((sub[1] == '')? new Array() : {} );
  					if (sub[1] == ''){ result[ind].push($(this).val()); } else { result[ind][sub[1]] = $(this).val(); }
  				} else {
  					result[attr] = $(this).val();
  				}
  			});
  			return result;
  		},
  		stripSlashes : function(str){
			return str.replace(/\\/g, '');
		}
	}
  	
	$.fn.admin = function(method) {
  		if ( methods[method] ) {
      		return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    	} else if ( typeof method === 'object' || ! method ) {
      		return methods.init.apply( this, arguments );
    	} else {
      		$.error( 'Method ' +  method + ' does not exist on jQuery.xbmc' );
    	}
    	    
	};
	
	$.fn.admin.defaults = {
		debug : true,
		method : 'init',
		templatemode : true,
		templatevars : {
			text : new Array('text'),
			image : new Array('img', 'text'),
			images : new Array('img', 'img', 'img', 'img', 'text'),
			video : new Array('video', 'text'),
			blog : new Array('img', 'text', 'img', 'text'),
			headline : new Array('headline')
		},
		editor: {},
		adminpath : 'admin/index.php',
		formpath : 'admin/form.php',
		scriptpath : 'include/private/js/',
		jscrolloptions : {
			autoReinitialise: false,
			animateScroll: true,
			contentWidth: 400
		},
		jscrollpanes : false,
		current : {},
		articles : {},
		hashnavigation : true,
		schplitzingid : false,
		schplitzingpass : false,
		schplitzingconnect : false,
		schplitzingconnected : false,
		lastconnection : false,
		logintime : false,
		lastlogin : false,
		screenshot : false
	};
	
})( jQuery );