<?php

class GetArticles extends db {

	protected $unserializekeys = array('fragments', 'extern_url');
	protected $template;
	protected $order = "sort";
	protected $table = 'sz_articles';
	
	public function getArticleById($id){
		$this->id = $id;
		$sql = "SELECT * from $this->table WHERE id='$this->id' LIMIT 1";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	public function getArticlesOfField($field){
		$sql = "SELECT * from $this->table WHERE field='$field' ORDER BY `$this->order`";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	public function getAllArticles($order = 'last_changed'){
		if ($order){
			$this->order = $order;
		}
		$sql = "SELECT * from $this->table ORDER BY `$this->order` DESC";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	public function getExternalArticles(){
		$sql = "SELECT * from $this->table WHERE extern='1'";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	public function getInternalArticles(){
		$sql = "SELECT * from $this->table WHERE extern='0'";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	public function getArticleInclRelations($id){
		$article = $this->getArticleById($id);
		$r = new GetRelations();
		$relations = $r->getRelationsById($id);
		foreach ($relations as $relation){
			if ($relation->relationfield != $article[0]->field){
				$art = $this->getArticleById($relation->relationid);
				$result[$art[0]->field] = $art[0];
			}
		}
		$result[$article[0]->field] = $article[0];
		return $result;
	}
	
	public function getArticleTitles(){
		$sql = "SELECT id, title from $this->table ORDER BY `field`, `sort` DESC";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	
}
	
	
	
?>