<?php  

class GetFragments extends db {

	protected $unserializekeys = array('html', 'articles');
	public $type;
	public $order = "type";
	public $way = "ASC";
	protected $table = 'sz_fragments';
	
	function __construct(){
		parent::__construct();
		$this->order = (isset($_GET['order'])) ? $_GET['order'] : $this->order;
	}
	
	public function getAllFragments($order = false, $tags=false){
		if ($order){
			$this->order = $order;
		}
		$sql = "SELECT * from  $this->table ORDER BY `$this->order` $this->way";
		$result = $this->fetchSql($sql);
		$result = $this->unserializeResult($result);
		if ($tags){
			$result = $this->nameTags($result);
		}
		return $result;
	}
	
	public function getFragmentsOfArticle($ids, $tags=false){
		if (is_array($ids)){
			foreach ($ids as $k=>$v){
				if ($v){
					$eids[$k] = $v;
				}
			}
			$id = "(".implode(",", $eids).")";
			$sql = "SELECT * from  $this->table WHERE id IN $id";
			$res = $this->fetchSql($sql);
			$result = array();
			foreach ($ids as $key=>$val){
				foreach ($res as $fra){
					if ($fra->id == $val){
						$result[$key] = $fra;
					}
				}
				if (!isset($result[$key])){
					$result[$key] = false;
				}
			}
		} else {
			$sql = "SELECT * from  $this->table WHERE id='$ids'";
			$result = $this->fetchSql($sql);
		}
		$result = $this->unserializeResult($result);
		if ($tags){
			$result = $this->nameTags($result);
		}
		return $result;
	}
	
	public function getFragmentsById($id, $tags=false){
		$this->id = $id;
		$sql = "SELECT * from  $this->table WHERE id='$this->id' LIMIT 1";
		$result = $this->fetchSql($sql);
		if ($tags){
			$result = $this->nameTags($result);
		}
		return $this->unserializeResult($result);
	}
	
	public function getFragmentsByType($type, $order = false, $tags = false){
		if ($order){
			$this->order = $order;
		}
		$this->type = $type;
		$sql = "SELECT * from  $this->table WHERE type='$this->type' ORDER BY `$this->order` ASC";
		$result = $this->fetchSql($sql);
		$result = $this->unserializeResult($result);
		if ($tags){
			$result = $this->nameTags($result);
		}
		return $result;
	}
	
	public function getFragmentsByTags($tags){
		$this->order = $order;
		if (is_array($tags)){
			$tags = implode("' OR WHERE type='", $tags);
			$sql = "SELECT * from  $this->table WHERE type='$tags' ORDER BY `$this->order` ASC";
			$result = $this->fetchSql($sql);
		} else {
			$sql = "SELECT * from  $this->table WHERE type='$tags' ORDER BY `$this->order` ASC";
			$result = $this->fetchSql($sql);
		}
		return $this->unserializeResult($result);
	}
	
	public function getFragmentsUsed($order = false){
		if ($order){
			$this->order = $order;
		}
		$sql = "SELECT * from  $this->table WHERE articles<>NULL ORDER BY `$this->order` ASC";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	public function getFragmentsNotUsed($order = false){
		if ($order){
			$this->order = $order;
		}
		$sql = "SELECT * from  $this->table WHERE articles='' ORDER BY `$this->order` ASC";
		$result = $this->fetchSql($sql);
		return $this->unserializeResult($result);
	}
	
	protected function nameTags($fragments){
		if ($fragments){
			$tag = new GetTags();
			foreach ($fragments as $k=>$f){
				$fragments[$k]->tags = $tag->getTagNameById($f->tags);
			}
		}
		return $fragments;
	}

}

?>