<?php

class Update extends Admin {

	function __construct(){
		parent::__construct();
	}
	
	public function updateConnections(){
		if ($this->logedIn){
			$result = array('status'=>false, 'infos'=>false, 'intern'=>false, 'extern'=>false, 'relations'=>false);
			$result['infos']->title = $this->infos->title;
			$result['infos']->subtitle = $this->infos->subtitle;
			$result['infos']->screenshot = $this->infos->screenshot;
			$result['infos']->author = utf8_encode(serialize($this->infos->author));
			$result['infos']->address = utf8_encode(serialize($this->infos->address));
			$result['infos']->decription = $this->infos->decription;
			$result['infos']->last_changed = $this->infos->last_changed;
			$a = new GetArticles();
			$r = new GetRelations();
			$intern = $a->getInternalArticles();
			foreach ($intern as $key=>$article){
				$result['intern'][$key]->id = $article->id;
				$result['intern'][$key]->title = $article->title;
				$result['intern'][$key]->lead = $article->lead;
				$result['intern'][$key]->text = strip_tags($article->cache);
				$result['intern'][$key]->field = $article->field;
				$result['intern'][$key]->template = $article->template;
				$result['intern'][$key]->author = $article->author;
				$result['intern'][$key]->last_changed = $article->last_changed;
			}
			$extern = $a->getExternalArticles();
			foreach ($extern as $key=>$article){
				$result['extern'][$key]->originarticleid = $article->id;
				$result['extern'][$key]->originfield = $article->field;
				$result['extern'][$key]->last_changed = $article->last_changed;
			}
			$relations = $r->getAllRelations('relationfield');
			foreach ($relations as $key=>$relation){
				if (!isset($result['relations'][$relation->articleid])){
					$article = $a->getArticleById($relation->articleid);
					$article = ($article)? $article[0] : $article;
					if ($article){
						$result['relations'][$relation->articleid]->last_changed = $relation->last_changed;
						$result['relations'][$relation->articleid]->systemarticleid = $article->id;
						$result['relations'][$relation->articleid]->articleid = ($article->extern)? $article->extern_id : $article->id;
						$result['relations'][$relation->articleid]->systemid = ($article->extern)? $article->extern_system : $this->infos->identifier;
						$result['relations'][$relation->articleid]->articlefield = $article->field;
						$result['relations'][$relation->articleid]->relationfield = array();
						$result['relations'][$relation->articleid]->relationid = array();
						$result['relations'][$relation->articleid]->relationsystem = array();
					} else {
						$rel = new Relations();
						$rel->deleteRelations($relation->articleid);
						$result['deleted']['relations'][] = $relation->articleid;
					}
				}
				
				if (in_array($relation->relationfield, $result['relations'][$relation->articleid]->relationfield)){
					$rel = new Relations();
					$rel->deleteRelationById($relation->id);
					$result['deleted']['single_relations'][] = $relation->id;
				} else if($result['relations'][$relation->articleid]->articlefield != $relation->relationfield) {
					$result['relations'][$relation->articleid]->relationfield[] = $relation->relationfield;
					if (is_numeric($relation->relationid)){
						$article = $a->getArticleById($relation->relationid);
						$article = ($article)? $article[0] : $article;
						$result['relations'][$relation->articleid]->relationid[] = ($article->extern)? $article->extern_id : $article->id;
						$result['relations'][$relation->articleid]->relationsystem[] = ($article->extern)? $article->extern_system : 0;
					} else {
						$result['relations'][$relation->articleid]->relationid[] = $relation->relationid;
						$result['relations'][$relation->articleid]->relationsystem[] = 0;
					}
				}
			}
			$result['status'] = true;
			echo json_encode($result);
		}
	}

}


?>