<div id="m<?= $field ?>" class="menu <?= ($field%2 == 0)? 'menu_right' : 'menu_left' ?> content" data-field="<?= $field ?>">
	<ul class="menu_list" data-field="<?= $field ?>">
		<li id="menu_list_item_w<?= $field ?>" class="menu_list_item" data-id="w<?= $field ?>">
			<?= ($field%2 == 0)? '<span class="menu_list_point">•</span>':'' ?><span class="menu_list_title white_title"><?= $this->lang['WHITE_ARTICLE'] ?></span><?= ($field%2 != 0)? '<span class="menu_list_point">•</span>':'' ?>
			
		</li>
		<?php if ($articles): foreach ($articles as $k=>$article): ?>
			<li id="menu_list_item_<?= $article->id ?>" class="menu_list_item" data-id="<?= $article->id ?>">
				<?= ($field%2 == 0)? '<span class="menu_list_point">•</span>':'' ?><span class="menu_list_title"><?= $article->title ?></span><?= ($field%2 != 0)? '<span class="menu_list_point">•</span>':'' ?>
			</li>
		<?php endforeach; endif; ?>
		<li id="menu_list_item_e<?= $field ?>" class="menu_list_item" data-id="e<?= $field ?>">
			<?= ($field%2 == 0)? '<span class="menu_list_point">•</span>':'' ?><span class="menu_list_title white_title"><?= $this->lang['NOT_RELATED'] ?></span><?= ($field%2 != 0)? '<span class="menu_list_point">•</span>':'' ?>
		</li>
	</ul>
</div>
<div id="header_<?= $field ?>" class="edit_header content">
	<div class="edit_title"><?= $this->lang['FIELD'] ?> <?= $field ?> - <?= $fieldnames[$field] ?></div>
</div>
<div id="content_buttons_<?= $field ?>" class="content_buttons content">
	<div class="edit_tools">
		<button class="txtbutton checkrelations" title="<?= $this->lang['CHECK_RELATIONS'] ?>" data-struct="relations" data-field="<?= $field ?>"><?= $this->lang['CHECK_RELATIONS'] ?></button>
		<button class="txtbutton saverelations" title="<?= $this->lang['SAVE_RELATIONS'] ?>" data-struct="relations" data-field="<?= $field ?>"><?= $this->lang['SAVE_RELATIONS'] ?></button>
		<button class="txtbutton plus" title="<?= $this->lang['ADD'] ?>" data-struct="article" data-field="<?= $field ?>" data-next="<?= count($articles)+1 ?>"><?= $this->lang['ADD'] ?></button>
	</div>
</div>
<div id="field_container_<?= $field ?>" class="field_container edit" data-field="<?= $field ?>" style="width:400px;height:300px">
	<ul class="relationslist content" data-field="<?= $field ?>">
		<li id="listed_article_w<?= $field ?>" class="listed_article white" data-id="w<?= $field ?>" data-sort="w" data-f1="e" data-f2="e" data-f3="e" data-f4="e">
			<div id="w<?= $field ?>" class="article"></div>
		</li>
		<?php if ($articles): ?>
			<?php foreach ($articles as $article): ?>
				<?php $relations = $rel->getRelationsForAllFields($article->id); ?>
				<li id="listed_article_<?= $article->id ?>" class="listed_article" data-id="<?= $article->id ?>" data-sort="<?= $article->sort ?>" data-extern="<?= $article->extern ?>"<?php if($article->extern): ?> data-system="<?= $article->extern_system ?>"  data-articleid="<?= $article->extern_id ?>" data-url="<?= $article->extern_url ?>"<?php endif; ?> data-relations='<?= json_encode($relations); ?>'>
					<div class="content_tools">
						<div class="template_icon">[<?= $article->template ?>]</div>
						<div class="article_title<?= ($article->extern)? ' extern_article' : '' ?>"><?= $article->title ?></div>
						<div class="article_tools">
							<button class="icon delete" data-struct="article" data-field="<?= $field ?>" data-id="<?= $article->id ?>" data-extern="<?= $article->extern ?>" title="<?= $this->lang['DELETE'] ?>"></button>
							<button class="icon edit" data-struct="article" data-field="<?= $field ?>" data-id="<?= $article->id ?>" data-extern="<?= $article->extern ?>" title="<?= $this->lang['EDIT'] ?>"></button>
						</div>
					</div>
					<?php if($article->extern): ?>
						<div id="<?= $article->id ?>" class="article extern" data-extern="1" data-externid="<?= $article->extern_id ?>" data-url="<?= $article->extern_url ?>" data-relations='<?= json_encode($relations); ?>'>
						</div>
					<?php else: ?>
						<?= $article->cache ?>
					<?php endif; ?>
				</li>
			<?php endforeach; ?>
		<?php endif; ?>
		<li id="listed_article_e<?= $field ?>" class="listed_article white" data-id="e<?= $field ?>" data-sort="e" data-f1="e" data-f2="e" data-f3="e" data-f4="e">
			<div id="e<?= $field ?>" class="article"><span class="unrelated"><?= $this->lang['NOT_RELATED'] ?></span></div>
		</li>
	</ul>
</div>