<?php
	error_reporting(E_ALL); 
	ini_set("display_errors", 0);
	ini_set("log_errors", 1);
	ini_set('error_log','error_php.log'); 
?><!DOCTYPE HTML>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title>SchplitZing - Installation</title>
	<link rel="stylesheet" type="text/css" href="include/public/css/style.css" />
	<link rel="stylesheet" type="text/css" href="include/private/css/admin.css" />
	<link rel="stylesheet" type="text/css" href="include/public/css/schplitzing.css" />
	<style type="text/css" >
		.label_invalid {
			color: red;
		}
	</style>
	
</head>
<body>
	<div id="edit_submenu_above"><div id="edit_submenu_menu" style="text-transform:none">
		<a href="http://www.SchplitZing.com" style="font-weight:bold;font-size:16px;line-height:20px;font-family:Georgia;" target="_blank">SchplitZing</a><br/>
		Installation
	</div></div>
	<div id="edit"><div id="main"><?php

$origin = (strpos($_SERVER['HTTP_HOST'], 'http://') === false)? 'http://'.$_SERVER['HTTP_HOST'].str_replace("index.php", "", $_SERVER['PHP_SELF']) : $_SERVER['HTTP_HOST'].str_replace("index.php", "", $_SERVER['PHP_SELF']);

$result = false;
if ($_POST){
	$form = false;
	$_POST['name'] = $_POST['author']['firstname'].' '.$_POST['author']['name'];
	$_POST['email'] = $_POST['address']['email'];
	$result = install();
	foreach ($result as $valid){
		if ($valid != false){
			$form = true;
		}
	}
} else {
	$form = true;
}
if ($form){
	$out = '<div class="edit_header standard edit_infos navigate">
				<div class="edit_tools">
					<button class="txtbutton install" data-form="infos_form" title="save">save</button>
				</div>
			</div>
			<div class="edit_half">';
	if (file_exists('felder.php')){
		$out .= '<div class="whiteblock info_text">';
			$out .= 'If you have already a SchplitZing installed and want to migrate the System you can do this here <a href="include/install/migrate.php" >Schplitzing migration</a>';
		$out .= '</div>';
	}
	if ($result['config']){
		$out .= '<div class="whiteblock info_text label_invalid">';
			$out .= 'You don\'t have the permission to write the configuration-file on your server. Please change the mode of the file "include/config/config.inc.php" to 766';
		$out .= '</div>';
	}
	$out .= '<form id="infos_form" class="infoform" action="index.php" method="POST" enctype="multipart/form-data">';
	$out .= '<input type="hidden" name="identifier" value="'.$_POST['identifier'].'" />';
	$out .= '<input type="hidden" name="identifierpass" value="'.$_POST['identifierpass'].'" />';
	$out .= '<input type="hidden" name="origin" value="'.$origin.'" />';
	$out .= '<div class="whiteblock">';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="title">Title*</label></div>
					<input type="text" name="title" class="formfield" value="'.$_POST['title'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="subtitel">Subtitle</label></div>
					<input type="text" name="subtitle" class="formfield" value="'.$_POST['subtitle'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="description">Description</label></div>
					<textarea name="description" class="formlead">'.$_POST['description'].'</textarea>
				</div>';
	$out .= '</div>';
	$out .= '<div class="whiteblock">';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="author[firstname]">First name*</label></div>
					<input type="text" name="author[firstname]" class="formfield" value="'.$_POST['author']['firstname'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="author[name]">Name*</label></div>
					<input type="text" name="author[name]" class="formfield" value="'.$_POST['author']['name'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="address[address01]">Address</label></div>
					<input type="text" name="address[address01]" class="formfield" value="'.$_POST['address']['address01'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="address[address02]">Address</label></div>
					<input type="text" name="address[address02]" class="formfield" value="'.$_POST['address']['address02'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="address[zip]">ZIP City</label></div>
					<input type="text" name="address[zip]" class="formfield small" value="'.$_POST['address']['zip'].'" />
					<input type="text" name="address[city]" class="formfield mid" value="'.$_POST['address']['city'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="address[country]">Country</label></div>
					<input type="text" name="address[country]" class="formfield" value="'.$_POST['address']['country'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['email'])){
			$out .= ($result['email'])? ' label_invalid' : '';
		}
		$out .= '" for="address[email]">Email*</label></div>
					<input type="text" name="address[email]" class="formfield" value="'.$_POST['address']['email'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel" for="address[tel]">Phone</label></div>
					<input type="text" name="address[tel]" class="formfield" value="'.$_POST['address']['tel'].'" />
				</div>';
	$out .= '</div>';
	$out .= '<div class="whiteblock">';
		$out .= '<div class="formblock textblock"><div class="label">&nbsp;</div>Database</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_HOST">Host*</label></div>
					<input type="text" name="DB_HOST" class="formfield" value="'.$_POST['DB_HOST'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$port = (isset($_POST['DB_PORT']))? $_POST['DB_PORT'] : '8889';
		$out .= '" for="DB_PORT">Port*</label></div>
					<input type="text" name="DB_PORT" class="formfield" value="'.$port.'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_NAME">Database*</label></div>
					<input type="text" name="DB_NAME" class="formfield" value="'.$_POST['DB_NAME'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_USER">User*</label></div>
					<input type="text" name="DB_USER" class="formfield" value="'.$_POST['DB_USER'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['db'])){
			$out .= ($result['db'])? ' label_invalid' : '';
		}
		$out .= '" for="DB_PASSWORD">Passwort*</label></div>
					<input type="text" name="DB_PASSWORD" class="formfield" value="'.$_POST['DB_PASSWORD'].'" />
				</div>';
	$out .= '</div>';
	$out .= '<div class="whiteblock">';
		$out .= '<div class="formblock textblock"><div class="label">&nbsp;</div>Create User</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['user']['username'])){
			$out .= ($result['user']['username'])? ' label_invalid' : '';
		}
		$out .= '" for="username">Username*</label></div>
					<input type="text" name="username" class="formfield" value="'.$_POST['username'].'" />
				</div>';
		$out .= '<div class="formblock textblock">
					<div class="label"><label class="formlabel';
		if (isset($result['user']['password'])){
			$out .= ($result['user']['password'])? ' label_invalid' : '';
		}
		$out .= '" for="password">Password*</label></div>
					<input type="text" name="password" class="formfield" value="'.$_POST['password'].'" />
				</div>';
		$out .= '</div>';
	$out .= '</form>';
	$out .= '</div>';
} else {
	$out = '<div class="edit_half">';
		$out .= '<div class="whiteblock info_text">';
			$out .= 'Your SchplitZing is now installed and you can start adding content <a href="'.$origin.'#about">'.$_POST['title'].'</a>.';
		$out .= '</div>';
	$out .= '</div>';
}

echo $out;

function install(){
	$db;
	$host = $_POST['DB_HOST'];
	$port = $_POST['DB_PORT'];
	$name = $_POST['DB_NAME'];
	$username = $_POST['DB_USER'];
	$password = $_POST['DB_PASSWORD'];
	
	$error = array('db'=>false,'createtable'=>array(),'insert'=>array(),'email'=>false,'config'=>false,'errorcode'=>false,'user'=>array());
	
	try {
		$db = new PDO("mysql:host=$host;port=$port;dbname=$name",$username,$password);
		$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	} catch(PDOException $e) {
		$error['db'] = true;
		$error['errorcode'] = $e->getMessage();
	}
	
	if (isValidEmail($_POST['address']['email']) && $_POST['name'] != '' && $_POST['username'] != '' && $_POST['password'] != ''){
		if (is_object($db)){

			$origin = (strpos($_SERVER['HTTP_HOST'], 'http://') === false)? 'http://'.$_SERVER['HTTP_HOST'].str_replace("index.php", "", $_SERVER['PHP_SELF']) : $_SERVER['HTTP_HOST'].str_replace("index.php", "", $_SERVER['PHP_SELF']);
			$sql['article'] = "CREATE TABLE IF NOT EXISTS sz_articles (
			  id int(10) NOT NULL AUTO_INCREMENT,
			  sort int(10) NOT NULL,
			  visibility tinyint(1) NOT NULL DEFAULT 1,
			  extern tinyint(1) NOT NULL DEFAULT 0,
			  field tinyint(1) NOT NULL,
			  title varchar(400) DEFAULT NULL,
			  lead text,
			  fragments varchar(200) DEFAULT NULL,
			  template varchar(10) NOT NULL,
			  extern_system varchar(32) NOT NULL,
			  extern_id int(10) DEFAULT NULL,
			  extern_url varchar(200) NOT NULL,
			  cache text NOT NULL,
			  author varchar(200) NOT NULL,
			  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  PRIMARY KEY (id)
			) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
			
			$sql['fragments'] = "CREATE TABLE IF NOT EXISTS sz_fragments (
			  id int(10) NOT NULL AUTO_INCREMENT,
			  type varchar(10) NOT NULL,
			  articles varchar(200) DEFAULT NULL,
			  tags tinyint(5) DEFAULT NULL,
			  title varchar(400) NOT NULL,
			  text text NOT NULL,
			  path varchar(200) DEFAULT NULL,
			  resource varchar(200) DEFAULT NULL,
			  thumb varchar(200) DEFAULT NULL,
			  size varchar(50) DEFAULT NULL,
			  html text,
			  source varchar(400) DEFAULT NULL,
			  source_url varchar(400) DEFAULT NULL,
			  author varchar(100) DEFAULT NULL,
			  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  PRIMARY KEY (id)
			) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
			
			$sql['infos'] = "CREATE TABLE IF NOT EXISTS sz_infos (
			  id int(1) NOT NULL AUTO_INCREMENT,
			  title varchar(500) NOT NULL,
			  subtitle varchar(500) NOT NULL,
			  description text NOT NULL,
			  screenshot varchar(200) DEFAULT NULL,
			  keywords text NOT NULL,
			  categories text NOT NULL,
			  startarticle TINYINT(5) NULL DEFAULT NULL,
			  author varchar(200) NOT NULL,
			  address varchar(500) NOT NULL,
			  language VARCHAR(4) NOT NULL DEFAULT 'en',
			  fields varchar(200) NOT NULL DEFAULT 'a:4:{i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";}',
			  identifier varchar(32) NOT NULL,
			  identifierpass varchar(13) NOT NULL,
			  connect int(1) NOT NULL DEFAULT 0,
			  last_connected DATETIME NOT NULL DEFAULT '2010-06-03 19:00:00',
			  public tinyint(1) NOT NULL DEFAULT 1,
			  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  PRIMARY KEY (id)
			) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
			
			$sql['relations'] = "CREATE TABLE IF NOT EXISTS sz_relations (
			  id int(10) NOT NULL AUTO_INCREMENT,
			  articleid int(10) NOT NULL,
			  relationid varchar(10) NOT NULL,
			  relationfield int(2) NOT NULL,
			  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  PRIMARY KEY (id)
			) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
			
			$sql['tags'] = "CREATE TABLE IF NOT EXISTS sz_tags (
			  id int(10) NOT NULL AUTO_INCREMENT,
			  tag varchar(300) NOT NULL,
			  description text NOT NULL,
			  author varchar(200) DEFAULT NULL,
			  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  PRIMARY KEY (id)
			) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
			
			$sql['user'] = "CREATE TABLE IF NOT EXISTS sz_user (
			  id int(10) NOT NULL AUTO_INCREMENT,
			  name varchar(50) NOT NULL,
			  username varchar(20) NOT NULL,
			  password varchar(30) NOT NULL,
			  type varchar(10) NOT NULL DEFAULT 'admin',
			  email varchar(100) NOT NULL,
			  last_login DATETIME NOT NULL,
			  last_changed timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  PRIMARY KEY (id)
			) DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci";
			
			$sz_infos = array('title', 'subtitle', 'description', 'screenshot', 'keywords', 'categories', 'author', 'address', 'fields', 'identifier', 'identifierpass', 'last_changed');
			$sz_user = array('name', 'username', 'password', 'type', 'email', 'last_changed');
			
			$infos = serializeProperties($sz_infos, $db);
			$create['infos'] = "INSERT INTO sz_infos (";
			$create['infos'] .= join(", ", array_keys($infos));
			$create['infos'] .= ") VALUES ('";
			$create['infos'] .= join("', '", array_values($infos));
			$create['infos'] .= "')";
					
			$user = serializeProperties($sz_user, $db);
			$create['user'] = "INSERT INTO sz_user (";
			$create['user'] .= join(", ", array_keys($user));
			$create['user'] .= ") VALUES ('";
			$create['user'] .= join("', '", array_values($user));
			$create['user'] .= "')";
				
			$config = file('include/config/config.inc.php');
			
			foreach ($config as $key=>$var){
				if (strstr($var, 'DOMAIN') != false && strstr($var, '// ') == false ) {
					$config[$key] = 'defined(\'DOMAIN\') ? null : define("DOMAIN", "'.$origin.'");'."\n";
				} else if (strstr($var, 'ROOT') != false && strstr($var, '// ') == false ){
					$config[$key] = 'defined(\'ROOT\') ? null : define("ROOT", "'.str_replace("/index.php", "", $_SERVER['SCRIPT_FILENAME']).'/");'."\n";
				} else if (strstr($var, 'DB_HOST') != false && strstr($var, '// ') == false ){
					$db_host = (isset($_POST['DB_HOST']))? $_POST['DB_HOST'] : 'localhost';
					$config[$key] = 'defined(\'DB_HOST\') ? null : define("DB_HOST", "'.$db_host.'");'."\n";
				} else if (strstr($var, 'DB_NAME') != false && strstr($var, '// ') == false ){
					$db_name = (isset($_POST['DB_NAME']))? $_POST['DB_NAME'] : 'sz';
					$config[$key] = 'defined(\'DB_NAME\') ? null : define("DB_NAME", "'.$db_name.'");'."\n";
				} else if (strstr($var, 'DB_USER') != false && strstr($var, '// ') == false ){
					$db_user = (isset($_POST['DB_USER']))? $_POST['DB_USER'] : false;
					$config[$key] = 'defined(\'DB_USER\') ? null : define("DB_USER", "'.$db_user.'");'."\n";
				} else if (strstr($var, 'DB_PORT') != false && strstr($var, '// ') == false ){
					$db_port = (isset($_POST['DB_PORT']))? $_POST['DB_PORT'] : '8889';
					$config[$key] = 'defined(\'DB_PORT\') ? null : define("DB_PORT", "'.$db_port.'");'."\n";
				} else if (strstr($var, 'DB_PASSWORD') != false && strstr($var, '// ') == false ){
					$db_pass = (isset($_POST['DB_PASSWORD']))? $_POST['DB_PASSWORD'] : false;
					$config[$key] = 'defined(\'DB_PASSWORD\') ? null : define("DB_PASSWORD", "'.$db_pass.'");'."\n";
				}
			}
		
		
			$installed_config = implode('', $config);
			$configfile = 'include/config/config.inc.php';
			$handle = fopen($configfile, 'w');
			$error['config'] = (!fwrite($handle, $installed_config))? true : false;
			fclose($handle);
			if (!$error['config']){
				echo "creating tables";
				foreach ($sql as $key=>$table){
					$statement = $db->prepare($table);
					try {
						$statement->execute();
					} catch(PDOException $e) {
						$error['create'][$key] = $e->getMessage();
					}
					if (isset($create[$key])){
						$statement = $db->prepare($create[$key]);
						try {
							$statement->execute();
						} catch(PDOException $e) {
							$error['insert'][$key] = $e->getMessage();
						}
					}
				}
			}
		} else {
			$error['db'] = true;
		}
	} else {
		if (!isValidEmail($_POST['address']['email'])){
			$error['email'] = true;
		}
		if ($_POST['name'] == ''){
			$error['user']['name'] = true;
		}
		if ($_POST['username'] == ''){
			$error['user']['username'] = true;
		}
		if ($_POST['password'] == ''){
			$error['user']['password'] = true;
		}
		$error['config'] = false;
	}	
	return $error;
}

function serializeProperties($array=array(), $db){
	$result = false;
	foreach ($array as $field){
		if (isset($_POST[$field])){
			if (is_array($_POST[$field])){
				$result[$field] = serialize($_POST[$field]);
			} else {
				if (!($result[$field] = utf8_decode($_POST[$field]))){
					$result[$field] = utf8_decode($_POST[$field]);
				}
			}
		}
	}
	return $result;
}

function isValidEmail($email){
	$regex = '/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/';
	$res = (preg_match($regex, $email))? true : false;
	return $res;
}


?></div>
	</div>
	<script type="text/javascript" src="include/public/js/jquery-1.7.1.min.js"></script>
	<script type="text/javascript" src="include/private/js/jquery.form.js"></script>
	<script type="text/javascript" src="include/install/schplitzing.validation.js"></script>
</body></html>