<?php
/*
------------------
Language: DEUTSCH
------------------
*/

$lang = array();

$langcode = array(
	'en'=>'Englisch',
	'de'=>'Deutsch'
);

// ADMIN

$lang['NOT_CONFIGURED'] = "Dein SchplitZing scheint nicht korrekt eingerichtet zu sein";
$lang['BOOKMARKLET'] = 'bookmarklet';
$lang['BOOKMARKLET_HELP'] = 'ziehe dieses Bookmarklet in die Lesezeichenleiste deines Browsers';
$lang['OR'] = 'oder';
$lang['TRY_CONNECT'] = 'Dein SchplitZing ist noch nicht mit der zentralen Datenbank verbunden. Klicke hier um Artikel mit anderen SchplitZing-Autoren austauschen zu können.';
$lang['BUTTON_CONNECT'] = 'connect';

// MENU

$lang['SETTINGS'] = 'Infos';
$lang['USER'] = 'Benutzer';
$lang['TAGS'] = 'Tags';
$lang['FRAGMENTS'] = 'Fragmente';
$lang['ARTICLES'] = 'Artikel';
$lang['RELATIONS'] = 'Verlinkungen';
$lang['CONTENT_RELATIONS'] = 'Content and Relations';
$lang['SCHPLITZING'] = 'SchplitZing';
$lang['FRONT'] = 'SchplitZing';
$lang['ABOUT'] = 'About';
$lang['CONTENT'] = 'Editieren';
$lang['SHOWABOUT'] = 'mehr';
$lang['NETWORK'] = 'Netzwerk';
$lang['SHOW_RELATIONS'] = 'show relations';
$lang['SHOW_CONTENT'] = 'show content';
$lang['COMPOSE'] = 'compose article';

// BUTTONS

$lang['LOGIN'] = 'login';
$lang['LOGOUT'] = 'logout';
$lang['SAVE'] = 'sichern';
$lang['CANCEL'] = 'abrechen';
$lang['EDIT'] = 'editieren';
$lang['DELETE'] = 'löschen';
$lang['ADD'] = 'hinzufügen';
$lang['NEW'] = 'neu';
$lang['REMOVE'] = 'entfernen';
$lang['SORT_BY'] = 'sortieren nach';
$lang['SORT_TAGS'] = 'Tags';
$lang['SORT_TYPE'] = 'Typ';
$lang['SORT_DATE'] = 'Datum';
$lang['SZ_EXTERN'] = 'extern';
$lang['SZ_CONNECTIONS'] = 'connections';
$lang['SZ_RELATIONS'] = 'relations';

// FORMS

$lang['TITLE'] = 'Titel';
$lang['SUBTITLE'] = 'Untertitel';
$lang['DESCRIPTION'] = 'Beschreibung';
$lang['KEYWORDS'] = 'Keywörter';
$lang['FIRST_NAME'] = 'Vorname';
$lang['LAST_NAME'] = 'Name';
$lang['ADDRESS_01'] = 'Adresse';
$lang['ADDRESS_02'] = 'Adresse';
$lang['ZIP'] = 'PLZ';
$lang['CITY'] = 'Ort';
$lang['COUNTRY'] = 'Land';
$lang['EMAIL'] = 'Email';
$lang['TELEPHONE'] = 'Tel';
$lang['FIELDS'] = 'Felder';
$lang['FIELD'] = 'Feld';
$lang['AUTHOR'] = 'Autor';
$lang['COLLABORATORS'] = 'Collaborators';
$lang['LINK'] = 'Link';
$lang['LANGUAGE'] = 'Sprache';
$lang['LOGIN_TEXT'] = 'only for Author and Collaborators';

$lang['NAME'] = 'Name';
$lang['USERNAME'] = 'Benutzername';
$lang['PASSWORD'] = 'Passwort';
$lang['PASSWORD_REPEAT'] = 'Passwort';
$lang['USERTYPE'] = 'Typ';

$lang['TAG'] = 'Tag';
$lang['TAG_DESCRIPTION'] = 'Beschreibung';
$lang['NOT_TAGGED'] = 'ohne Tag';
$lang['ADD_TAG'] = 'Tag hinzufügen';

$lang['SOURCE'] = 'Quelle';
$lang['SOURCE_URL'] = 'Quelle URL';
$lang['VIDEO_SOURCE'] = 'Quelle';
$lang['URL_OR_ID'] = 'ID oder URL';
$lang['REPLACE_IMAGE'] = 'Bild ersetzen';
$lang['REPLACE_VIDEO'] = 'Video ersetzen';
$lang['VIMEO'] = 'Vimeo';
$lang['YOUTUBE'] = 'YouTube';
$lang['SOUNDCLOUD'] = 'SoundCloud';

$lang['FRAGMENT'] = 'Fragment';
$lang['NEW_FRAGMENT'] = 'neu';
$lang['ADD_FRAGMENT'] = 'Fragment hinzufügen';
$lang['DROP_FRAGMENT'] = 'Drop Fragment hier';
$lang['ADD_FRAGMENT_OF_TYPE'] = 'Fragment nach Typ hinzufügen';
$lang['FRAGMENT_USED'] = 'Das Fragment wird in folgenden Artikeln benutzt:';
$lang['DELETE_ANYWAY'] = 'Trotzdem löschen?';

$lang['ARTICLE'] = 'Artikel';
$lang['TEMPLATE'] = 'Vorlage';
$lang['VISIBILITY'] = 'Sichtbarkeit';
$lang['VISIBILITY_ARTICLE'] = 'im Artikel';
$lang['VISIBILITY_MENU'] = 'im Menu';

$lang['LEAD'] = 'Lead';

$lang['ADD_ARTICLE'] = 'Artikel hinzufügen';
$lang['CHECK_RELATIONS'] = 'Verlinkung prüfen';
$lang['SAVE_RELATIONS'] = 'Verlinkung sichern';
$lang['WHITE_ARTICLE'] = 'Weiss';
$lang['NOT_RELATED'] = 'Nicht verlinkt';

$lang['SCREENSHOT'] = 'Screenshot';
$lang['CREATE_SCREENSHOT'] = 'Screenshot generieren';
$lang['UPLOAD_SCREENSHOT'] = 'Screenshot hochladen';
$lang['CHOOSE_ARTICLE'] = 'Artikel';

// SCHPLITZING

$lang['SEARCH'] = 'suchen';
$lang['TITLE_EXTERNAL'] = 'externe Artikel';
$lang['TITLE_SEARCH'] = 'in SchplitZing Library suchen';
$lang['SEARCH_BY'] = 'Suche nach';
$lang['SEARCH_BY_AUTHOR'] = 'Autor';
$lang['SEARCH_BY_URL'] = 'URL';
$lang['SEARCH_BY_TITLE'] = 'Titel';
$lang['SEARCH_BY_FULLTEXT'] = 'Volltext';
$lang['NO_EXTERNAL'] = 'Keine externen Artikel in diesem SchplitZing';
$lang['SEARCH_IN'] = 'Suche in';
$lang['SEARCH_IN_SYSTEM'] = 'SchplitZings';
$lang['SEARCH_IN_ARTICLES'] = 'Artikel';
$lang['SEARCH_IN_ALL'] = 'überall';
$lang['SEARCH_TERM'] = 'Suche nach';
$lang['RESULT'] = 'Resultat';
$lang['PREVIEW'] = 'Vorschau';
$lang['PREVIEW_ARTICLE'] = 'Artikel';
$lang['PREVIEW_RELATIONS'] = 'Verlinkungen';
$lang['CONNECTIONS_NEW'] = 'Verbindungen';
$lang['RELATIONS_NEW'] = 'Verlinkungen zu Artikeln in deinem SchplitZing';
$lang['CONNECTION_TITLE'] = 'Verbindung';
$lang['CONNECTION_SCHPLITZING'] = 'SchplitZing';
$lang['CONNECTION_ARTICLES'] = 'Eigene Artikel mit Verbindungen in externe SchplitZings';
$lang['ARTICLE_OFFLINE'] = 'Offline';
$lang['ABOUT_SCHPLITZING'] = 'about SchplitZing';

?>