<!DOCTYPE HTML>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title><?= $this->infos->title ?></title>
	<?php if(!$this->logedIn): ?><link rel="stylesheet" type="text/css" href="include/private/css/connect.css" /><?php endif; ?>
	<link rel="stylesheet" type="text/css" href="include/public/css/style.css" />
	<link rel="stylesheet" type="text/css" href="include/public/css/texte.css" />
	<link rel="stylesheet" type="text/css" href="include/public/css/headline.css" />
	<link rel="stylesheet" type="text/css" href="include/public/css/jquery.jscrollpane.css" />
	<?php if($this->logedIn): ?><link rel="stylesheet" type="text/css" href="include/private/css/admin.css" /><?php endif; ?>
	<link rel="stylesheet" type="text/css" href="include/public/css/schplitzing.css" />
	
</head>
<body>
	<div id="header" data-origin="<?= DOMAIN ?>">
		<div id="header_loading"<?php if($this->structure == 'front' || !$this->logedIn): ?> class="loading"<?php endif; ?> ></div>
		<div id="header_info"><span class="header_title"><?= $this->infos->title ?></span><br/>
			<span class="header_subtitle"><?= $this->infos->subtitle ?>…</span><?php if($this->structure == 'front' || !$this->logedIn): ?> <span class="show_about"><?= $this->lang['SHOWABOUT'] ?></span><?php endif; ?><br>
			<span class="info_contact"><?php foreach($this->infos->author as $author): ?><?= $author.' '; ?><?php endforeach; ?><?php if($this->infos->address['city'] != ''): ?> | <?= $this->infos->address['city'] ?><?php endif; ?></span><br>
			<?php if($this->structure == 'front' || !$this->logedIn): ?>
				<div id="header_connections">
					<div class="show_connections con_connections" data-show="extern_list"></div><div class="show_connections extern_connections" data-show="connections_list"></div>
					<ul class="header_connections_list extern_list"></ul>
					<ul class="header_connections_list connections_list"></ul>
				</div>
			<?php endif; ?>
		</div>
	</div>
